
CREATE TABLE IF NOT EXISTS `#__digistore_cart` (
  `cid` int(11) NOT NULL auto_increment,
  `item_id` int(11) NOT NULL default '0',
  `userid` int(11) NOT NULL default '0',
  `quantity` int(11) NOT NULL default '0',
  `sid` int(11) NOT NULL default '0',
  `plan_id` int(11) NOT NULL default '0',
  `plugin_id` int(11) NOT NULL default '0',
  `renew` int(11) NOT NULL default '0',
  `renewlicid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`cid`),
  KEY `productid` (`item_id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_cartfields` (
  `fieldid` int(11) NOT NULL default '0',
  `productid` int(11) NOT NULL default '0',
  `sid` int(11) NOT NULL default '0',
  `optionid` int(11) NOT NULL default '-1',
  `cid` int(11) NOT NULL default '0'
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_categories` (
  `id` int(11) NOT NULL auto_increment,
  `parent_id` int(11) NOT NULL default '0',
  `title` varchar(50) NOT NULL default '',
  `name` varchar(255) NOT NULL default '',
  `image` varchar(500) default NULL,
  `section` varchar(50) NOT NULL default '',
  `image_position` varchar(10) NOT NULL default '',
  `description` text NOT NULL,
  `published` tinyint(1) NOT NULL default '0',
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `editor` varchar(50) default NULL,
  `ordering` int(11) NOT NULL default '0',
  `access` tinyint(3) unsigned NOT NULL default '0',
  `count` int(11) NOT NULL default '0',
  `metakeywords` text NOT NULL,
  `metadescription` text NOT NULL,
  `images` text NOT NULL,
  `params` text NOT NULL,
  `thumb` varchar(500) NOT NULL,
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_currencies` (
  `id` int(11) NOT NULL auto_increment,
  `pluginid` varchar(30) NOT NULL default '',
  `currency_name` varchar(20) NOT NULL default '',
  `currency_full` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

INSERT IGNORE INTO `#__digistore_currencies` (`pluginid`,`currency_name`,`currency_full`) 
VALUES ('1','USD','U.S. Dollar'),
('1','AUD','Australian Dollar'),
('1','CAD','Canadian Dollar'),
('1','CHF','Swiss Franc'),
('1','CZK','Czech Koruna'),
('1','DKK','Danish Krone'),
('1','EUR','Euro'),
('1','GBP','Pound Sterling'),
('1','HKD','Hong Kong Dollar'),
('1','HUF','Hungarian Forint'),
('1','JPY','Japanese Yen'),
('1','NOK','Norwegian Krone'),
('1','NZD','New Zealand Dollar'),
('1','PLN','Polish Zloty'),
('1','SEK','Swedish Krona'),
('1','SGD','Singapore Dollar'),
('1','ILS','Israeli New Shekel (ILS)'),
('1','MXN','Mexican Peso (MXN)'),
('1','BRL','Brazilian Real (BRL)'),
('1','MYR','Malaysian Ringgit (MYR)'),
('1','PHP','Philippine Peso (PHP)'),
('1','TWD','New Taiwan Dollar (TWD)'),
('1','THB','Thai Baht (THB)'),
('1','TRY','Turkish Lira (TRY)');

drop table if exists `#__digistore_currency_symbols`;

CREATE TABLE IF NOT EXISTS `#__digistore_currency_symbols` (
  `id` int(11) NOT NULL auto_increment,
  `ccode` varchar(5) NOT NULL default '',
  `csym` varchar(255) NOT NULL default '',
  `cimg` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

insert into `#__digistore_currency_symbols` (`ccode`, `csym`, `cimg`) values 
('ALL', '76, 101, 107', 'curSymbol76-101-107.gif'),
('USD', '36', 'curSymbol36.gif'),
('AFN', '1547', 'curSymbol1547.gif'),
('ARS', '36', 'curSymbol36.gif'),
('AWG', '402', 'curSymbol402.gif'),
('AUD', '36', 'curSymbol36.gif'),
('AZN', '1084, 1072, 1085', 'curSymbol1084-1072-1085.gif'),
('BSD', '36', 'curSymbol36.gif'),
('BBD', '36', 'curSymbol36.gif'),
('BYR', '112, 46', 'curSymbol112-46.gif'),
('BEF', '8355', 'curSymbol8355.gif'),
('BZD', '66, 90, 36', 'curSymbol66-90-36.gif'),
('BMD', '36', 'curSymbol36.gif'),
('BOB', '36, 98', 'curSymbol36-98.gif'),
('BAM', '75, 77', 'curSymbol75-77.gif'),
('BWP', '80', 'curSymbol80.gif'),
('BGN', '1083, 1074', 'curSymbol1083-1074.gif'),
('BRL', '82, 36', 'curSymbol82-36.gif'),
('BRC', '8354', 'curSymbol8354.gif'),
('GBP', '163', 'curSymbol163.gif'),
('BND', '36', 'curSymbol36.gif'),
('KHR', '6107', 'curSymbol6107.gif'),
('CAD', '36', 'curSymbol36.gif'),
('KYD', '36', 'curSymbol36.gif'),
('CLP', '36', 'curSymbol36.gif'),
('CNY', '20803', 'curSymbol20803.gif'),
('COP', '36', 'curSymbol36.gif'),
('CRC', '8353', 'curSymbol8353.gif'),
('HRK', '107, 110', 'curSymbol107-110.gif'),
('CUP', '8369', 'curSymbol8369.gif'),
('CYP', '163', 'curSymbol163.gif'),
('CZK', '75, 269', 'curSymbol75-269.gif'),
('DKK', '107, 114', 'curSymbol107-114.gif'),
('DOP', '82, 68, 36', 'curSymbol82-68-36.gif'),
('XCD', '36', 'curSymbol36.gif'),
('EGP', '163', 'curSymbol163.gif'),
('SVC', '36', 'curSymbol36.gif'),
('GBP', '163', 'curSymbol163.gif'),
('EEK', '107, 114', 'curSymbol107-114.gif'),
('EUR', '8364', 'curSymbol8364.gif'),
('XEU', '8352', 'curSymbol8352.gif'),
('FKP', '163', 'curSymbol163.gif'),
('FJD', '36', 'curSymbol36.gif'),
('FRF', '8355', 'curSymbol8355.gif'),
('GHC', '162', 'curSymbol162.gif'),
('GIP', '163', 'curSymbol163.gif'),
('GRD', '8367', 'curSymbol8367.gif'),
('GTQ', '81', 'curSymbol81.gif'),
('GGP', '163', 'curSymbol163.gif'),
('GYD', '36', 'curSymbol36.gif'),
('NLG', '402', 'curSymbol402.gif'),
('HNL', '76', 'curSymbol76.gif'),
('HKD', '72, 75, 36', 'curSymbol72-75-36.gif'),
('HKD', '22291', 'curSymbol22291.gif'),
('HKD', '22291', 'curSymbol22291.gif'),
('HKD', '20803', 'curSymbol20803.gif'),
('HUF', '70, 116', 'curSymbol70-116.gif'),
('ISK', '107, 114', 'curSymbol107-114.gif'),
('INR', '8360', 'curSymbol8360.gif'),
('IDR', '82, 112', 'curSymbol82-112.gif'),
('IRR', '65020', 'curSymbol65020.gif'),
('IEP', '163', 'curSymbol163.gif'),
('IMP', '163', 'curSymbol163.gif'),
('ILS', '8362', 'curSymbol8362.gif'),
('ITL', '8356', 'curSymbol8356.gif'),
('JMD', '74, 36', 'curSymbol74-36.gif'),
('JPY', '165', 'curSymbol165.gif'),
('JEP', '163', 'curSymbol163.gif'),
('KZT', '1083, 1074', 'curSymbol1083-1074.gif'),
('KPW', '8361', 'curSymbol8361.gif'),
('KRW', '8361', 'curSymbol8361.gif'),
('KGS', '1083, 1074', 'curSymbol1083-1074.gif'),
('LAK', '8365', 'curSymbol8365.gif'),
('LVL', '76, 115', 'curSymbol76-115.gif'),
('LBP', '163', 'curSymbol163.gif'),
('LRD', '36', 'curSymbol36.gif'),
('CHF', '67, 72, 70', 'curSymbol67-72-70.gif'),
('LTL', '76, 116', 'curSymbol76-116.gif'),
('LUF', '8355', 'curSymbol8355.gif'),
('MKD', '1076, 1077, 1085', 'curSymbol1076-1077-1085.gif'),
('MYR', '82, 77', 'curSymbol82-77.gif'),
('MTL', '76, 109', 'curSymbol76-109.gif'),
('MUR', '8360', 'curSymbol8360.gif'),
('MXN', '36', 'curSymbol36.gif'),
('MNT', '8366', 'curSymbol8366.gif'),
('MZN', '77, 84', 'curSymbol77-84.gif'),
('NAD', '36', 'curSymbol36.gif'),
('NPR', '8360', 'curSymbol8360.gif'),
('ANG', '402', 'curSymbol402.gif'),
('NLG', '402', 'curSymbol402.gif'),
('NZD', '36', 'curSymbol36.gif'),
('NIO', '67, 36', 'curSymbol67-36.gif'),
('NGN', '8358', 'curSymbol8358.gif'),
('KPW', '8361', 'curSymbol8361.gif'),
('NOK', '107, 114', 'curSymbol107-114.gif'),
('OMR', '65020', 'curSymbol65020.gif'),
('PKR', '8360', 'curSymbol8360.gif'),
('PAB', '66, 47, 46', 'curSymbol66-47-46.gif'),
('PYG', '71, 115', 'curSymbol71-115.gif'),
('PEN', '83, 47, 46', 'curSymbol83-47-46.gif'),
('PHP', '80, 104, 112', 'curSymbol80-104-112.gif'),
('PLN', '122, 322', 'curSymbol122-322.gif'),
('QAR', '65020', 'curSymbol65020.gif'),
('RON', '108, 101, 105', 'curSymbol108-101-105.gif'),
('RUB', '1088, 1091, 1073', 'curSymbol1088-1091-1073.gif'),
('SHP', '163', 'curSymbol163.gif'),
('SAR', '65020', 'curSymbol65020.gif'),
('RSD', '1044, 1080, 1085, 46', 'curSymbol1044-1080-1085-46.gif'),
('SCR', '8360', 'curSymbol8360.gif'),
('SGD', '36', 'curSymbol36.gif'),
('SKK', '83, 73, 84', 'curSymbol83-73-84.gif'),
('EUR', '8364', 'curSymbol8364.gif'),
('SBD', '36', 'curSymbol36.gif'),
('SOS', '83', 'curSymbol83.gif'),
('ZAR', '82', 'curSymbol82.gif'),
('KRW', '8361', 'curSymbol8361.gif'),
('ESP', '8359', 'curSymbol8359.gif'),
('LKR', '8360', 'curSymbol8360.gif'),
('SEK', '107, 114', 'curSymbol107-114.gif'),
('CHF', '67, 72, 70', 'curSymbol67-72-70.gif'),
('SRD', '36', 'curSymbol36.gif'),
('SYP', '163', 'curSymbol163.gif'),
('TWD', '78, 84, 36', 'curSymbol78-84-36.gif'),
('THB', '3647', 'curSymbol3647.gif'),
('TTD', '84, 84, 36', 'curSymbol84-84-36.gif'),
('TRY', '89, 84, 76', 'curSymbol89-84-76.gif'),
('TRL', '8356', 'curSymbol8356.gif'),
('TVD', '36', 'curSymbol36.gif'),
('UAH', '8372', 'curSymbol8372.gif'),
('GBP', '163', 'curSymbol163.gif'),
('USD', '36', 'curSymbol36.gif'),
('UYU', '36, 85', 'curSymbol36-85.gif'),
('UZS', '1083, 1074', 'curSymbol1083-1074.gif'),
('VAL', '8356', 'curSymbol8356.gif'),
('VEB', '66, 115', 'curSymbol66-115.gif'),
('VND', '8363', 'curSymbol8363.gif'),
('YER', '65020', 'curSymbol65020.gif'),
('ZWD', '90, 36', 'curSymbol90-36.gif');

CREATE TABLE IF NOT EXISTS `#__digistore_customers` (
	`id` int(11) NOT NULL AUTO_INCREMENT,
	`firstname` varchar(50) NOT NULL DEFAULT '',
	`lastname` varchar(50) NOT NULL DEFAULT '',
	`address` varchar(200) NOT NULL DEFAULT '',
	`city` varchar(100) DEFAULT NULL,
	`state` varchar(100) DEFAULT NULL,
	`province` varchar(100) DEFAULT NULL,
	`zipcode` varchar(20) NOT NULL DEFAULT '',
	`country` varchar(100) NOT NULL DEFAULT '',
	`phone` varchar(45) NOT NULL DEFAULT '',
	`payment_type` varchar(20) NOT NULL DEFAULT '',
	`company` varchar(100) NOT NULL DEFAULT '',


	`shipfirstname` varchar(50) NOT NULL DEFAULT '',
	`shiplastname` varchar(50) NOT NULL DEFAULT '',
	`shipaddress` varchar(200) NOT NULL DEFAULT '',
	`shipcity` varchar(100) DEFAULT NULL,
	`shipstate` varchar(100) DEFAULT NULL,
	`shipprovince` varchar(100) DEFAULT NULL,
	`shipzipcode` varchar(20) NOT NULL DEFAULT '',
	`shipcountry` varchar(100) DEFAULT NULL,
	`shipphone` varchar(45) NOT NULL DEFAULT '',

	`person` int(2) NOT NULL DEFAULT '0',
	`taxnum` varchar(11) DEFAULT '1',
	`taxclass` int(11) NOT NULL DEFAULT '0',

	PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_customfields` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(200) NOT NULL default '',
  `options` text NOT NULL,
  `published` int(2) NOT NULL default '0',
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL default '0',
  `size` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_emailreminders` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL,
  `type` int(11) NOT NULL,
  `subject` varchar(255) NOT NULL,
  `body` text NOT NULL,
  `ordering` int(11) NOT NULL,
  `published` int(11) NOT NULL,
  `period` VARCHAR( 5 ) NULL ,
  `calc` VARCHAR( 6 ) NULL ,
  `date_calc` VARCHAR( 10 ) NULL ,
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


INSERT IGNORE INTO `#__digistore_emailreminders` (`id`, `name`, `type`, `subject`, `body`, `ordering`, `published`)
VALUES
	(1, '2 days before expiration', 2, '[CUSTOMER_FIRST_NAME], your subscription to [PRODUCT_NAME] is about to expire', '<p>Dear [CUSTOMER_FIRST_NAME], <br /> <br /> Just a quick note to let you know that your subscription to  [PRODUCT_NAME], with license number [LICENSE_NUMBER], will expire in 2  days ([EXPIRE_DATE]). Please visit [SITENAME] and renew your  subscription here: <br /> <br /> [RENEW_URL]  <br /> <br /> Your username to login is: [CUSTOMER_USER_NAME] and your email in case your''ve forgotten your password is: [CUSTOMER_EMAIL]  <br /> <br /> We offer the following renewal plans: <br /> <br /> [RENEW_TERM] 	 <br /> <br /> You can always renew your subscription or view your licenses here: <br /> <br /> [MY_LICENSES] <br /> <br /> Thank you, <br /> [SITENAME] <br /> Admin</p>', 3, 1),
	(2, 'On expiration', 0, '[CUSTOMER_FIRST_NAME], your subscription to [PRODUCT_NAME] has expired', '<p>Dear [CUSTOMER_FIRST_NAME], <br /> <br /> Just a quick note to let you know that your subscription to  [PRODUCT_NAME], with license number [LICENSE_NUMBER], has expired on  ([EXPIRE_DATE]). Please visit [SITENAME] and renew your subscription  here: <br /> <br /> [RENEW_URL]  <br /> <br /> Your username to login is: [CUSTOMER_USER_NAME] and your email in case your''ve forgotten your password is: [CUSTOMER_EMAIL]  <br /> <br /> We offer the following renewal plans: <br /> <br /> [RENEW_TERM] 	 <br /> <br /> You can always renew your subscription or view your licenses here: <br /> <br /> [MY_LICENSES] <br /> <br /> Thank you, <br /> [SITENAME] <br /> Admin</p>', 2, 1),
	(3, '2 days after expiration', 7, '[CUSTOMER_FIRST_NAME], your subscription to [PRODUCT_NAME] is about to expire', '<p>Dear [CUSTOMER_FIRST_NAME], <br /> <br /> Just a quick note to let you know that your subscription to  [PRODUCT_NAME], with license number [LICENSE_NUMBER], has expired on  ([EXPIRE_DATE]). Please visit [SITENAME] and renew your subscription  here: <br /> <br /> [RENEW_URL]  <br /> <br /> Your username to login is: [CUSTOMER_USER_NAME] and your email in case your''ve forgotten your password is: [CUSTOMER_EMAIL]  <br /> <br /> We offer the following renewal plans: <br /> <br /> [RENEW_TERM] 	 <br /> <br /> You can always renew your subscription or view your licenses here: <br /> <br /> [MY_LICENSES] <br /> <br /> Thank you, <br /> [SITENAME] <br /> Admin</p>', 1, 1);


CREATE TABLE IF NOT EXISTS `#__digistore_featuredproducts` (
  `productid` int(11) NOT NULL default '0',
  `featuredid` int(11) NOT NULL default '0',
  `planid` int(11) NOT NULL default '0'
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_fields` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL,
  `type` int(11) NOT NULL,
  `category` int(11) NOT NULL,
  `file` varchar(100) NOT NULL,
  `params` text NOT NULL,
  `comment` text NOT NULL,
  `published` tinyint(1) NOT NULL default '0',
  `access` tinyint(3) NOT NULL default '0',
  `checked_out` int(11) NOT NULL,
  `checked_out_time` datetime NOT NULL,
  `ordering` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_fieldsets` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL,
  `fields` text NOT NULL,
  `core` int(2) NOT NULL default '0',
  `editable` int(2) NOT NULL default '1',
  `comment` text NOT NULL,
  `published` tinyint(1) NOT NULL default '0',
  `access` tinyint(3) NOT NULL default '0',
  `checked_out` int(11) NOT NULL,
  `checked_out_time` datetime NOT NULL,
  `ordering` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_field_types` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default 'text',
  `default` text NOT NULL,
  `special` int(2) NOT NULL default '0',
  `published` tinyint(1) NOT NULL default '0',
  `access` tinyint(3) NOT NULL default '0',
  `checked_out` int(11) NOT NULL,
  `checked_out_time` datetime NOT NULL,
  `ordering` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_languages` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(200) NOT NULL default '',
  `fefilename` text NOT NULL,
  `befilename` text NOT NULL,
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

truncate table `#__digistore_languages`;


CREATE TABLE IF NOT EXISTS `#__digistore_licensefields` (
  `licenseid` int(11) NOT NULL default '0',
  `fieldname` varchar(200) NOT NULL default '',
  `optioname` varchar(200) NOT NULL default ''
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_licenseprodfields` (
  `fieldid` int(11) NOT NULL default '0',
  `licenseid` int(11) NOT NULL default '0',
  `optionid` int(2) NOT NULL default '-1'
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_licenses` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `licenseid` varchar(20) NOT NULL DEFAULT '',
  `userid` int(11) NOT NULL DEFAULT '0',
  `productid` int(11) NOT NULL DEFAULT '0',
  `domain` varchar(100) NOT NULL DEFAULT '',
  `amount_paid` float NOT NULL DEFAULT '0',
  `orderid` int(11) NOT NULL DEFAULT '0',
  `dev_domain` text NOT NULL,
  `hosting_service` varchar(50) NOT NULL DEFAULT '',
  `published` int(2) NOT NULL DEFAULT '1',
  `ltype` varchar(200) NOT NULL DEFAULT 'common',
  `package_id` int(11) NOT NULL,
  `purchase_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `expires` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `renew` int(11) NOT NULL DEFAULT '0',
  `renewlicid` int(11) NOT NULL DEFAULT '0',
  `download_count` int(11) NOT NULL DEFAULT '0',
  `plan_id` int(11) NOT NULL DEFAULT '0',
  `old_orders` text NOT NULL,
  `cancelled` tinyint(1) NOT NULL default '0',
  `cancelled_amount` float NOT NULL default '0',
  `domain_change` int(11) NOT NULL default '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `licenseid` (`licenseid`),
  KEY `orderid` (`orderid`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_licenses_notes` (
  `id` int(11) NOT NULL auto_increment,
  `lic_id` int(11) NOT NULL,
  `notes` text NOT NULL,
  `expires` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_licenses_payments` (
  `id` int(11) NOT NULL auto_increment,
  `lic_id` int(11) NOT NULL,
  `amount` float NOT NULL default '0',
  `expires` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_mailtemplates` (
  `id` int(11) NOT NULL auto_increment,
  `type` varchar(50) NOT NULL default '',
  `subject` text NOT NULL,
  `body` text NOT NULL,
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_orders` (
  `id` int(11) NOT NULL auto_increment,
  `userid` int(11) NOT NULL default '0',
  `order_date` int(11) NOT NULL default '0',
  `amount` float NOT NULL default '0',
  `number_of_licenses` int(11) NOT NULL default '0',
  `currency` varchar(10) NOT NULL default '',
  `status` varchar(10) NOT NULL default '',
  `tax` float NOT NULL default '0',
  `shipping` float NOT NULL default '0',
  `promocodeid` int(11) NOT NULL default '0',
  `promocode` varchar(255) NOT NULL default '',
  `promocodediscount` float NOT NULL default '0',
  `shipto` int(2) NOT NULL default '0',
  `fullshipto` text NOT NULL,
  `amount_paid` float NOT NULL default '0',
  `processor` varchar(100) NOT NULL,
  `published` int(11) NOT NULL default '0',
  `chargeback` tinyint(1) NOT NULL default '0',
  `analytics` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

UPDATE `#__digistore_orders` SET `status`='Active' WHERE `status`='in_progres';


CREATE TABLE IF NOT EXISTS `#__digistore_plans` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL,
  `duration_count` int(11) NOT NULL,
  `duration_type` int(11) NOT NULL,
  `ordering` int(11) NOT NULL,
  `published` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

INSERT IGNORE INTO `#__digistore_plans` (`id`, `name`, `duration_count`, `duration_type`, `ordering`, `published`)
VALUES
	(1, '5 Downloads Access', 5, 0, 6, 1),
	(2, '1 Month Access', 1, 3, 5, 1),
	(3, '3 Months Access', 3, 3, 4, 1),
	(4, '6 Months Access', 6, 3, 3, 1),
	(5, '1 Year Access', 1, 4, 2, 1),
	(6, 'Unlimited Access', -1, 0, 1, 1);


CREATE TABLE IF NOT EXISTS `#__digistore_prodfields` (
  `fieldid` int(11) NOT NULL default '0',
  `productid` int(11) NOT NULL default '0',
  `publishing` int(2) NOT NULL default '0',
  `mandatory` int(2) NOT NULL default '0'
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_productclass` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(200) NOT NULL default '',
  `published` tinyint(4) NOT NULL default '0',
  `ordering` int(11) NOT NULL default '0',
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

INSERT IGNORE INTO `#__digistore_productclass` (`id`, `name`, `published`, `ordering`, `checked_out`, `checked_out_time`)
VALUES (1, 'General', 1, 0, 0, '0000-00-00 00:00:00');
 
CREATE TABLE IF NOT EXISTS `#__digistore_products` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(150) NOT NULL default '',
  `images` varchar(150) NOT NULL default '',
  `discount` float NOT NULL default '0',
  `ordering` int(11) NOT NULL default '0',
  `file` varchar(150) NOT NULL default '',
  `description` text NOT NULL,
  `publish_up` int(11) NOT NULL default '0',
  `publish_down` int(11) NOT NULL default '0',
  `checked_out` int(11) NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `published` int(11) NOT NULL default '0',
  `passphrase` varchar(150) NOT NULL default '',
  `main_zip_file` mediumtext NOT NULL,
  `encoding_files` text NOT NULL,
  `domainrequired` int(11) NOT NULL default '0',
  `articlelink` text NOT NULL,
  `articlelinkid` int(11) NOT NULL default '0',
  `articlelinkuse` int(3) NOT NULL default '0',
  `shippingtype` int(11) NOT NULL default '0',
  `shippingvalue0` float NOT NULL default '0',
  `shippingvalue1` float NOT NULL default '0',
  `shippingvalue2` float NOT NULL default '0',
  `productemailsubject` text NOT NULL,
  `productemail` text NOT NULL,
  `sendmail` int(11) NOT NULL default '1',
  `popupwidth` int(11) NOT NULL default '800',
  `popupheight` int(11) NOT NULL default '600',
  `stock` int(11) NOT NULL default '0',
  `used` int(11) NOT NULL default '0',
  `usestock` int(11) NOT NULL default '0',
  `emptystockact` int(11) NOT NULL default '0',
  `showstockleft` int(11) NOT NULL default '0',
  `fulldescription` text NOT NULL,
  `metatitle` varchar(100) NOT NULL default '',
  `metakeywords` text NOT NULL,
  `metadescription` text NOT NULL,
  `access` tinyint(3) unsigned NOT NULL default '0',
  `prodtypeforplugin` text NOT NULL,
  `taxclass` int(11) NOT NULL default '0',
  `class` int(11) NOT NULL default '0',
  `sku` varchar(100) NOT NULL default '',
  `showqtydropdown` int(11) NOT NULL default '0',
  `priceformat` int(11) NOT NULL default '1',
  `featured` int(11) NOT NULL default '0',
  `prodimages` text NOT NULL,
  `defprodimage` varchar(500) NOT NULL default '',
  `mailchimplistid` varchar(255) NOT NULL default '',
  `subtitle` varchar(255) NOT NULL default '',
  `mailchimpapi` text NOT NULL,
  `mailchimplist` text NOT NULL,
  `mailchimpregister` int(3) NOT NULL default '0',
  `mailchimpgroupid` text NOT NULL,
  `video_url` text NOT NULL,
  `video_width` int(11) NOT NULL default '0',
  `video_height` int(11) NOT NULL default '0',
  `offerplans` int(3) NOT NULL default '0',
  `hide_public` tinyint(1) NOT NULL default '0',
  `cartlinkuse` int(3) NOT NULL default '0',
  `cartlink` text NOT NULL,
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_products_images` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `product_id` int(11) NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL,
  `title` text NOT NULL,
  `default` int(3) NOT NULL,
  `order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__digistore_products_emailreminders` (
  `id` int(11) NOT NULL auto_increment,
  `product_id` int(11) NOT NULL,
  `emailreminder_id` int(11) NOT NULL,
  `send` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_products_plans` (
  `id` int(11) NOT NULL auto_increment,
  `product_id` int(11) NOT NULL,
  `plan_id` int(11) NOT NULL,
  `price` float NOT NULL,
  `default` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_products_renewals` (
  `id` int(11) NOT NULL auto_increment,
  `product_id` int(11) NOT NULL,
  `plan_id` int(11) NOT NULL,
  `price` float NOT NULL,
  `default` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__digistore_product_categories` (
  `productid` int(11) NOT NULL DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`productid`,`catid`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

CREATE TABLE IF NOT EXISTS `#__digistore_promocodes` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(200) NOT NULL default '',
  `code` varchar(100) NOT NULL default '',
  `codelimit` int(11) NOT NULL default '0',
  `amount` float NOT NULL default '0',
  `codestart` int(11) NOT NULL default '0',
  `codeend` int(11) NOT NULL default '0',
  `forexisting` int(11) NOT NULL default '0',
  `published` int(11) NOT NULL default '0',
  `aftertax` int(11) NOT NULL default '0',
  `promotype` int(11) NOT NULL default '0',
  `used` int(11) NOT NULL default '0',
  `validfornew` int(11) NOT NULL default '0',
  `validforrenewal` int(11) NOT NULL default '0',
  `ordering` int(11) NOT NULL default '0',
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `code` (`code`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_sendmails` (
  `id` int(11) NOT NULL auto_increment,
  `date` int(11) NOT NULL default '0',
  `email` varchar(40) NOT NULL default '',
  `body` text NOT NULL,
  `flag` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_session` (
  `sid` int(11) NOT NULL auto_increment,
  `create_time` int(11) NOT NULL default '0',
  `cart_details` text NOT NULL,
  `transaction_details` text NOT NULL,
  `shipping_details` int(11) NOT NULL default '0',
  `processor` varchar(250) NOT NULL,
  PRIMARY KEY  (`sid`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_settings` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `currency` varchar(10) NOT NULL DEFAULT 'USD',
  `catalogue` INT(2) NULL DEFAULT '0',
  `showviewproducts` INT(2) NOT NULL DEFAULT 1,
  `price_groups_separation` VARCHAR(2) NULL DEFAULT ',',
  `showproductdetails` INT(2) NOT NULL DEFAULT '1',
  `store_name` varchar(200) NOT NULL DEFAULT '',
  `store_url` varchar(200) NOT NULL DEFAULT '',
  `store_email` varchar(200) NOT NULL DEFAULT '',
  `product_per_page` int(11) NOT NULL DEFAULT '10',
  `google_account` varchar(20) NOT NULL DEFAULT '',
  `country` varchar(30) NOT NULL DEFAULT '',
  `state` varchar(30) NOT NULL DEFAULT '',
  `city` varchar(30) NOT NULL DEFAULT '',
  `tax_option` varchar(20) NOT NULL DEFAULT '',
  `tax_rate` float NOT NULL DEFAULT '0',
  `tax_type` varchar(20) NOT NULL DEFAULT '',
  `totaldigits` int(11) NOT NULL DEFAULT '5',
  `decimaldigits` int(11) NOT NULL DEFAULT '2',
  `ftp_source_path` varchar(100) NOT NULL DEFAULT 'media',
  `time_format` varchar(150) NOT NULL DEFAULT '',
  `afteradditem` int(11) NOT NULL DEFAULT '0',
  `showreplic` int(11) NOT NULL DEFAULT '0',
  `idevaff` varchar(100) NOT NULL DEFAULT 'notapplied',
  `askterms` int(11) NOT NULL DEFAULT '0',
  `termsid` int(11) NOT NULL DEFAULT '-1',
  `termsheight` int(11) NOT NULL DEFAULT '-1',
  `termswidth` int(11) NOT NULL DEFAULT '-1',
  `topcountries` text NOT NULL,
  `usestoremail` int(11) NOT NULL DEFAULT '1',
  `catlayoutstyle` int(11) NOT NULL DEFAULT '1',
  `catlayoutcol` int(11) NOT NULL DEFAULT '1',
  `catlayoutrow` int(11) NOT NULL DEFAULT '1',
  `prodlayouttype` int(11) NOT NULL DEFAULT '0',
  `prodlayoutstyle` int(11) NOT NULL DEFAULT '1',
  `prodlayoutcol` int(11) NOT NULL DEFAULT '1',
  `prodlayoutrow` int(11) NOT NULL DEFAULT '1',
  `orderidvar` varchar(100) NOT NULL DEFAULT 'order_id',
  `ordersubtotalvar` varchar(100) NOT NULL DEFAULT 'order_subtotal',
  `idevpath` varchar(255) NOT NULL DEFAULT 'aff',
  `askforship` int(2) NOT NULL DEFAULT '1',
  `person` int(2) NOT NULL DEFAULT '1',
  `taxnum` int(11) NOT NULL DEFAULT '0',
  `modbuynow` int(11) NOT NULL DEFAULT '0',
  `usecimg` int(2) NOT NULL DEFAULT '0',
  `showthumb` int(2) NOT NULL DEFAULT '0',
  `showsku` int(2) NOT NULL DEFAULT '0',
  `sendmailtoadmin` int(2) NOT NULL DEFAULT '1',
  `directfilelink` int(2) NOT NULL DEFAULT '0',
  `debugstore` int(2) NOT NULL DEFAULT '0',
  `dumptofile` int(2) NOT NULL DEFAULT '0',
  `dumpvars` text NOT NULL,
  `ftranshtml` text NOT NULL,
  `thankshtml` text NOT NULL,
  `showprodshort` int(11) NOT NULL DEFAULT '0',
  `pendinghtml` text NOT NULL,
  `address` varchar(255) NOT NULL DEFAULT '',
  `zip` varchar(100) NOT NULL DEFAULT '',
  `phone` varchar(200) NOT NULL DEFAULT '',
  `fax` varchar(200) NOT NULL DEFAULT '',
  `afterpurchase` int(2) NOT NULL DEFAULT '1',
  `showoid` int(2) NOT NULL DEFAULT '1',
  `showoipurch` int(2) NOT NULL DEFAULT '1',
  `showolics` int(2) NOT NULL DEFAULT '1',
  `showopaid` int(2) NOT NULL DEFAULT '1',
  `showodate` int(2) NOT NULL DEFAULT '1',
  `showorec` int(2) NOT NULL DEFAULT '1',
  `showlid` int(2) NOT NULL DEFAULT '1',
  `showlprod` int(2) NOT NULL DEFAULT '1',
  `showloid` int(2) NOT NULL DEFAULT '1',
  `showldate` int(2) NOT NULL DEFAULT '1',
  `showldown` int(2) NOT NULL DEFAULT '1',
  `showcam` int(2) NOT NULL DEFAULT '1',
  `showcpromo` int(2) NOT NULL DEFAULT '1',
  `showcremove` int(2) NOT NULL DEFAULT '1',
  `showccont` int(2) NOT NULL DEFAULT '1',
  `showldomain` int(2) NOT NULL DEFAULT '1',
  `tax_classes` int(11) NOT NULL DEFAULT '0',
  `tax_base` int(11) NOT NULL DEFAULT '0',
  `tax_catalog` int(11) NOT NULL DEFAULT '0',
  `tax_shipping` int(11) NOT NULL DEFAULT '0',
  `tax_discount` int(11) NOT NULL DEFAULT '0',
  `discount_tax` int(11) NOT NULL DEFAULT '0',
  `tax_country` varchar(200) NOT NULL DEFAULT '',
  `tax_state` varchar(200) NOT NULL DEFAULT '',
  `tax_zip` varchar(200) NOT NULL DEFAULT '',
  `tax_price` int(11) NOT NULL DEFAULT '0',
  `tax_summary` int(11) NOT NULL DEFAULT '0',
  `shipping_price` int(11) NOT NULL DEFAULT '0',
  `product_price` int(11) NOT NULL DEFAULT '0',
  `tax_zero` int(11) NOT NULL DEFAULT '0',
  `tax_apply` varchar(200) NOT NULL DEFAULT '',
  `usestorelocation` int(11) NOT NULL DEFAULT '0',
  `allowcustomerchoseclass` int(11) NOT NULL DEFAULT '2',
  `takecheckout` int(11) NOT NULL DEFAULT '1',
  `continue_shopping_url` varchar(500) NOT NULL,
  `currency_position` int(1) NOT NULL DEFAULT '0',
  `showlterms` int(1) NOT NULL DEFAULT '0',
  `showlexpires` int(1) NOT NULL DEFAULT '0',
  `storedesc` mediumtext NOT NULL,
  `displaystoredesc` int(11) NOT NULL DEFAULT '1',
  `showfeatured` int(11) NOT NULL DEFAULT '0',
  `showrelated` int(11) NOT NULL DEFAULT '0',
  `hour24format` int(11) NOT NULL DEFAULT '0',
  `imagecatsizevalue` int(11) NOT NULL DEFAULT '100',
  `imagecatsizetype` int(11) NOT NULL DEFAULT '1',
  `imageprodsizefullvalue` int(11) NOT NULL DEFAULT '300',
  `imageprodsizefulltype` int(11) NOT NULL DEFAULT '1',
  `imageprodsizethumbvalue` int(11) NOT NULL DEFAULT '100',
  `imageprodsizethumbtype` int(11) NOT NULL DEFAULT '1',
  `imagecatdescvalue` int(11) NOT NULL DEFAULT '10',
  `imagecatdesctype` int(11) NOT NULL DEFAULT '0',
  `imageproddescvalue` int(11) NOT NULL DEFAULT '10',
  `imageproddesctype` int(11) NOT NULL DEFAULT '0',
  `mailchimplistid` varchar(255) DEFAULT NULL,
  `showpowered` tinyint(4) NOT NULL DEFAULT '1',
  `catlayoutimagesize` int(10) NOT NULL,
  `catlayoutimagetype` int(10) NOT NULL,
  `catlayoutdesclength` int(10) NOT NULL,
  `catlayoutdesctype` int(10) NOT NULL,
  `prodlayoutdesclength` int(10) NOT NULL,
  `prodlayoutdesctype` int(10) NOT NULL,
  `showfeatured_prod` int(10) NOT NULL,
  `prodlayoutthumbnails` int(10) NOT NULL,
  `prodlayoutthumbnailstype` int(10) NOT NULL,
  `prodlayoutlargeimgprev` int(10) NOT NULL,
  `prodlayoutlargeimgprevtype` int(10) NOT NULL,
  `prodlayoutlightimgprev` int(10) NOT NULL,
  `prodlayoutlightimgprevtype` int(10) NOT NULL,
  `showshortdescription` int(10) NOT NULL,
  `showlongdescription` int(10) NOT NULL,
  `showrelatedprod` int(10) NOT NULL,
  `last_check_date` datetime NOT NULL,
  `prodlayoutsort` int(10) NOT NULL,
  `relatedrows` int(10) NOT NULL DEFAULT '1',
  `relatedcolumns` int(10) NOT NULL DEFAULT '3',
  `grid_image_align` int(10) NOT NULL DEFAULT '0',
  `grid_title_align` int(10) NOT NULL DEFAULT '2',
  `grid_subtitle_align` int(10) NOT NULL DEFAULT '2',
  `grid_description_align` int(10) NOT NULL DEFAULT '2',
  `grid_quantity_align` int(10) NOT NULL DEFAULT '2',
  `grid_add_to_cat_align` int(10) NOT NULL DEFAULT '2',
  `list_multi_selection` int(10) NOT NULL DEFAULT '1',
  `list_orientation` int(10) NOT NULL DEFAULT '0',
  `featured_row` int(10) NOT NULL DEFAULT '1',
  `featured_col` int(10) NOT NULL DEFAULT '3',
  `store_logo` varchar(255) NOT NULL,
  `shopping_cart_style` int(10) NOT NULL DEFAULT '0',
  `cart_width` varchar(255) NOT NULL DEFAULT '100',
  `cart_width_type` int(10) NOT NULL DEFAULT '1',
  `cart_alignment` int(10) NOT NULL DEFAULT '1',
  `prod_short_desc_class` varchar(255) NOT NULL DEFAULT 'digi_short_desc_page',
  `prod_long_desc_class` varchar(255) NOT NULL DEFAULT 'digi_long_desc_page',
  `prods_short_desc_class` varchar(255) NOT NULL DEFAULT 'digi_short_desc_list',
  `prods_price_class` varchar(255) NOT NULL DEFAULT 'digi_price_list',
  `prods_name_class` varchar(255) NOT NULL DEFAULT 'digi_name_list',
  `cart_popoup_image` int(10) NOT NULL DEFAULT '50',
  `gallery_style` int(3) NOT NULL DEFAULT '1',
  `gallery_columns` int(3) NOT NULL DEFAULT '3',
  `in_trans` int(10) NOT NULL DEFAULT '0',
  `show_bradcrumbs` int(3) NOT NULL DEFAULT '0',
  `mailchimpapi` text NOT NULL,
  `mailchimplist` text NOT NULL,
  `showfacebook` int(2) NOT NULL DEFAULT '1',
  `showtwitter` int(2) NOT NULL DEFAULT '1',
  `showretwitter` int(2) NOT NULL DEFAULT '1',
  `newinstall` int(3) NOT NULL DEFAULT '1',
  `tax_eumode` tinyint(1) NOT NULL DEFAULT '0',
  `askforbilling` int(2) NOT NULL DEFAULT '0',
  `show_steps` int(3) NOT NULL DEFAULT '0',
  `askforcompany` int(3) NOT NULL DEFAULT '0',
  `conversion_id` varchar(255) NOT NULL DEFAULT '',
  `conversion_language` varchar(255) NOT NULL DEFAULT 'en',
  `conversion_format` varchar(255) NOT NULL DEFAULT '2',
  `conversion_color` varchar(255) NOT NULL DEFAULT 'ffffff',
  `conversion_label` varchar(255) NOT NULL DEFAULT '',
  `default_payment` varchar(255) NOT NULL DEFAULT '',
  `thousands_group_symbol` varchar(5) NOT NULL DEFAULT ',',
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

DROP TABLE IF EXISTS `#__digistore_states`;

CREATE TABLE IF NOT EXISTS `#__digistore_states` (
  `id` int(11) NOT NULL auto_increment,
  `state` varchar(200) NOT NULL default '',
  `country` varchar(200) NOT NULL default '',
  `eumember` int(2) NOT NULL default '0',
  `ccode` varchar(5) NOT NULL default '',
  `scode` varchar(5) NOT NULL default '',
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

INSERT IGNORE INTO `#__digistore_states` (`id`, `state`, `country`, `eumember`, `ccode`, `scode`) VALUES 
 (1, 'Afghanistan', 'Afghanistan', '0','AF',''),
 (2, 'Algeria', 'Algeria', '0','DZ',''),
 (3, 'American-Samoa', 'American-Samoa', '0','AS',''),
 (4, 'Andorra', 'Andorra', '0','AD',''),
 (5, 'Angola', 'Angola', '0','AO',''),
 (6, 'Anguilla', 'Anguilla', '0','AI',''),
 (7, 'Antigua-and-Barbuda', 'Antigua-and-Barbuda', '0','AG',''),
 (8, 'Argentina', 'Argentina', '0','AR',''),
 (9, 'Armenia', 'Armenia', '0','AM',''),
 (10, 'Ascension-Island', 'Ascension-Island', '0','AC',''),
 (11, 'Australian Capital Territory', 'Australia', '0','AU',''),
 (12, 'Christmas Island', 'Australia', '0','AU',''),
 (13, 'New South Wales', 'Australia', '0','AU',''),
 (14, 'Northern Territory', 'Australia', '0','AU',''),
 (15, 'Queensland', 'Australia', '0','AU',''),
 (16, 'South Australia', 'Australia', '0','AU',''),
 (17, 'Tasmania', 'Australia', '0','AU',''),
 (18, 'Victoria', 'Australia', '0','AU',''),
 (19, 'Western Australia', 'Australia', '0','AU',''),
 (20, 'Austria', 'Austria', '1','AT',''),
 (21, 'Azerbaijan', 'Azerbaijan', '0','AZ',''),
 (22, 'Bahamas', 'Bahamas', '0','BS',''),
 (23, 'Bahrain', 'Bahrain', '0','BH',''),
 (24, 'Bangladesh', 'Bangladesh', '0','BD',''),
 (25, 'Barbados', 'Barbados', '0','BB',''),
 (26, 'Belarus', 'Belarus', '0','BY',''),
 (27, 'Belgium', 'Belgium', '1','BE',''),
 (28, 'Belize', 'Belize', '0','BZ',''),
 (29, 'Benin', 'Benin', '0','BJ',''),
 (30, 'Bermuda', 'Bermuda', '0','BM',''),
 (31, 'Bhutan', 'Bhutan', '0','BT',''),
 (32, 'Bolivia', 'Bolivia', '0','BO',''),
 (33, 'Bosnia-and-Herzegovina', 'Bosnia-and-Herzegovina', '0','BA',''),
 (34, 'Botswana', 'Botswana', '0','BW',''),
 (35, 'Brazil', 'Brazil', '0','BR',''),
 (36, 'Sergipe', 'Brazil', '0','BR',''),
 (37, 'British-Indian-Ocean-Territory', 'British-Indian-Ocean-Territory', '0','IO',''),
 (38, 'Brunei-Darussalam', 'Brunei-Darussalam', '0','BN',''),
 (39, 'Bulgaria', 'Bulgaria', '1','BG',''),
 (40, 'Burkina-Faso', 'Burkina-Faso', '0','BF',''),
 (41, 'Burundi', 'Burundi', '0','BI',''),
 (42, 'Camaroon', 'Camaroon', '0','CM',''),
 (43, 'Cambodia', 'Cambodia', '0','KH',''),
 (44, 'Cameroon', 'Cameroon', '0','CM',''),
 (45, 'Alberta', 'Canada', '0','CA',''),
 (46, 'British Columbia', 'Canada', '0','CA',''),
 (47, 'Manitoba', 'Canada', '0','CA',''),
 (48, 'New Brunswick', 'Canada', '0','CA',''),
 (49, 'Newfoundland', 'Canada', '0','CA',''),
 (50, 'Northwest Territories', 'Canada', '0','CA',''),
 (51, 'Nova Scotia', 'Canada', '0','CA',''),
 (52, 'Nunavut', 'Canada', '0','CA',''),
 (53, 'Ontario', 'Canada', '0','CA',''),
 (54, 'Prince Edward Island', 'Canada', '0','CA',''),
 (55, 'Quebec', 'Canada', '0','CA',''),
 (56, 'Saskatchewan', 'Canada', '0','CA',''),
 (57, 'Yukon', 'Canada', '0','CA',''),
 (58, 'Cape-Verde', 'Cape-Verde', '0','CV',''),
 (59, 'Cayman-Islands', 'Cayman-Islands', '0','KY',''),
 (60, 'Central-African-Republic', 'Central-African-Republic', '0','CF',''),
 (61, 'Chad', 'Chad', '0','TD',''),
 (62, 'Chile', 'Chile', '0','CL',''),
 (63, 'Anhui', 'China', '0','CN',''),
 (64, 'Beijing', 'China', '0','CN',''),
 (65, 'China', 'China', '0','CN',''),
 (66, 'Fujian', 'China', '0','CN',''),
 (67, 'Gansu', 'China', '0','CN',''),
 (68, 'Guangdong', 'China', '0','CN',''),
 (69, 'Guangxi', 'China', '0','CN',''),
 (70, 'Guizhou', 'China', '0','CN',''),
 (71, 'Hebei', 'China', '0','CN',''),
 (72, 'Heilongjiang', 'China', '0','CN',''),
 (73, 'Henan', 'China', '0','CN',''),
 (74, 'Hong-Kong', 'China', '0','CN',''),
 (75, 'Hubei', 'China', '0','CN',''),
 (76, 'Hunan', 'China', '0','CN',''),
 (77, 'Jiangsu', 'China', '0','CN',''),
 (78, 'Jiangxi', 'China', '0','CN',''),
 (79, 'Jilin', 'China', '0','CN',''),
 (80, 'Liaoning', 'China', '0','CN',''),
 (81, 'Macau', 'China', '0','CN',''),
 (82, 'Nei Mongol', 'China', '0','CN',''),
 (83, 'Ningxia', 'China', '0','CN',''),
 (84, 'Quinghai', 'China', '0','CN',''),
 (85, 'Shaanxi', 'China', '0','CN',''),
 (86, 'Shandong', 'China', '0','CN',''),
 (87, 'Shanghai', 'China', '0','CN',''),
 (88, 'Shanxi', 'China', '0','CN',''),
 (89, 'Sichuan', 'China', '0','CN',''),
 (90, 'Taiwan', 'China', '0','CN',''),
 (91, 'Tianjin', 'China', '0','CN',''),
 (92, 'Xinjiang', 'China', '0','CN',''),
 (93, 'Xizang', 'China', '0','CN',''),
 (94, 'Yunnan', 'China', '0','CN',''),
 (95, 'Zhejiang', 'China', '0','CN',''),
 (96, 'Colombia', 'Colombia', '0','CO',''),
 (97, 'Comoros', 'Comoros', '0','KM',''),
 (98, 'Congo', 'Congo', '0','CG',''),
 (99, 'Aitutaki', 'Cook-Islands', '0','CK',''),
 (100, 'Atiu', 'Cook-Islands', '0','CK',''),
 (101, 'Mangaia', 'Cook-Islands', '0','CK',''),
 (102, 'Manuae', 'Cook-Islands', '0','CK',''),
 (103, 'Mauke', 'Cook-Islands', '0','CK',''),
 (104, 'Mitiaro', 'Cook-Islands', '0','CK',''),
 (105, 'Palmerston', 'Cook-Islands', '0','CK',''),
 (106, 'Rarotonga', 'Cook-Islands', '0','CK',''),
 (107, 'Suwarrow', 'Cook-Islands', '0','CK',''),
 (108, 'Tatutea', 'Cook-Islands', '0','CK',''),
 (109, 'Costa-Rica', 'Costa-Rica', '0','CR',''),
 (110, 'Cote-D-Ivoire', 'Cote-D-Ivoire', '0','CI',''),
 (111, 'Croatia', 'Croatia', '0','HR',''),
 (112, 'Cuba', 'Cuba', '0','CU',''),
 (113, 'Cyprus', 'Cyprus', '1','CY',''),
 (114, 'Czech-Republic', 'Czech-Republic', '1','CZ',''),
 (115, 'Denmark', 'Denmark', '1','DK',''),
 (116, 'Djibouti', 'Djibouti', '0','DJ',''),
 (117, 'Dominica', 'Dominica', '0','DM',''),
 (118, 'Dominican-Republic', 'Dominican-Republic', '0','DO',''),
 (119, 'Ecuador', 'Ecuador', '0','EC',''),
 (120, 'Egypt', 'Egypt', '0','EG',''),
 (121, 'El-Salvador', 'El-Salvador', '0','SV',''),
 (122, 'Equatorial-Guinea', 'Equatorial-Guinea', '0','GQ',''),
 (123, 'Eritrea', 'Eritrea', '0','ER',''),
 (124, 'Estonia', 'Estonia', '1','EE',''),
 (125, 'Ethiopia', 'Ethiopia', '0','ET',''),
 (126, 'Falkland-Islands', 'Falkland-Islands', '0','FK',''),
 (127, 'Faroe-Islands', 'Faroe-Islands', '0','FO',''),
 (128, 'Federated-States-of-Micronesia', 'Federated-States-of-Micronesia', '0','FM',''),
 (129, 'Kandavu', 'Fiji', '0','FJ',''),
 (130, 'Lau Group', 'Fiji', '0','FJ',''),
 (131, 'Ono-I-Lau', 'Fiji', '0','FJ',''),
 (132, 'Rotuma', 'Fiji', '0','FJ',''),
 (133, 'Taveuni', 'Fiji', '0','FJ',''),
 (134, 'Vanua Levu', 'Fiji', '0','FJ',''),
 (135, 'Vanua Mbalavu', 'Fiji', '0','FJ',''),
 (136, 'Vita Levu', 'Fiji', '0','FJ',''),
 (137, 'Finland', 'Finland', '1','FI',''),
 (138, 'Hame', 'Finland', '1','FI',''),
 (139, 'France', 'France', '1','FR',''),
 (140, 'French-Guiana', 'French-Guiana', '0','GF',''),
 (141, 'Ahunui Island', 'French-Polynesia', '0','PF',''),
 (142, 'Amanu Island', 'French-Polynesia', '0','PF',''),
 (143, 'Anaa Island', 'French-Polynesia', '0','PF',''),
 (144, 'Bellingshausen Island', 'French-Polynesia', '0','PF',''),
 (145, 'Bora-Bora Island', 'French-Polynesia', '0','PF',''),
 (146, 'Fakarava Island', 'French-Polynesia', '0','PF',''),
 (147, 'Hao Island', 'French-Polynesia', '0','PF',''),
 (148, 'Haraiki Island', 'French-Polynesia', '0','PF',''),
 (149, 'Hikueru Island', 'French-Polynesia', '0','PF',''),
 (150, 'Hiva Oa Island', 'French-Polynesia', '0','PF',''),
 (151, 'Kaukura Island', 'French-Polynesia', '0','PF',''),
 (152, 'Makatea Island', 'French-Polynesia', '0','PF',''),
 (153, 'Makemo Island', 'French-Polynesia', '0','PF',''),
 (154, 'Manuhangi Island', 'French-Polynesia', '0','PF',''),
 (155, 'Maria Island', 'French-Polynesia', '0','PF',''),
 (156, 'Marutea Island', 'French-Polynesia', '0','PF',''),
 (157, 'Mataiva Island', 'French-Polynesia', '0','PF',''),
 (158, 'Mehetia Island', 'French-Polynesia', '0','PF',''),
 (159, 'Moorea Island', 'French-Polynesia', '0','PF',''),
 (160, 'Mopelia Island', 'French-Polynesia', '0','PF',''),
 (161, 'Nengonengo Island', 'French-Polynesia', '0','PF',''),
 (162, 'Raevavae Island', 'French-Polynesia', '0','PF',''),
 (163, 'Raiatea Island', 'French-Polynesia', '0','PF',''),
 (164, 'Rapa Island', 'French-Polynesia', '0','PF',''),
 (165, 'Raraka Island', 'French-Polynesia', '0','PF',''),
 (166, 'Raroia Island', 'French-Polynesia', '0','PF',''),
 (167, 'Ravahere Island', 'French-Polynesia', '0','PF',''),
 (168, 'Rimatara Island', 'French-Polynesia', '0','PF',''),
 (169, 'Rurutu Island', 'French-Polynesia', '0','PF',''),
 (170, 'Scilly Island', 'French-Polynesia', '0','PF',''),
 (171, 'Tahaa Island', 'French-Polynesia', '0','PF',''),
 (172, 'Tahiti Island', 'French-Polynesia', '0','PF',''),
 (173, 'Tahuata Island', 'French-Polynesia', '0','PF',''),
 (174, 'Takapoto Island', 'French-Polynesia', '0','PF',''),
 (175, 'Tematangi Island', 'French-Polynesia', '0','PF',''),
 (176, 'Tetiaroa Island', 'French-Polynesia', '0','PF',''),
 (177, 'Tikei Island', 'French-Polynesia', '0','PF',''),
 (178, 'Vanavana Island', 'French-Polynesia', '0','PF',''),
 (179, 'Gabon', 'Gabon', '0','GA',''),
 (180, 'Georgia', 'Georgia', '0','GE',''),
 (181, 'Bayern', 'Germany', '1','DE',''),
 (182, 'Brandenburg', 'Germany', '1','DE',''),
 (183, 'Bremen', 'Germany', '1','DE',''),
 (184, 'Germany', 'Germany', '1','DE',''),
 (185, 'Nordrhein-Westfalen', 'Germany', '1','DE',''),
 (186, 'Rheinland-Pfalz', 'Germany', '1','DE',''),
 (187, 'Sachsen', 'Germany', '1','DE',''),
 (188, 'Sachsen-Anhalt', 'Germany', '1','DE',''),
 (189, 'Thuringen', 'Germany', '1','DE',''),
 (190, 'Ghana', 'Ghana', '0','GH',''),
 (191, 'Gibralter', 'Gibralter', '0','GI',''),
 (192, 'Greece', 'Greece', '1','GR',''),
 (193, 'Greenland', 'Greenland', '0','GL',''),
 (194, 'Grenada', 'Grenada', '0','GD',''),
 (195, 'Guadeloupe', 'Guadeloupe', '0','GP',''),
 (196, 'Guam', 'Guam', '0','GU',''),
 (197, 'Guatemala', 'Guatemala', '0','GT',''),
 (198, 'Guinea', 'Guinea', '0','GN' ,''),
 (199, 'Guinea-Bissau', 'Guinea-Bissau', '0','GW',''),
 (200, 'Guyana', 'Guyana', '0','GY',''),
 (201, 'Haiti', 'Haiti', '0','HT',''),
 (202, 'Honduras', 'Honduras', '0','HN',''),
 (203, 'Hong-Kong', 'Hong-Kong', '0','HK',''),
 (204, 'Hungary', 'Hungary', '1','HU',''),
 (205, 'Iceland', 'Iceland', '0','IS',''),
 (206, 'Bass', 'Ilots', '0','',''),
 (207, 'de Gdansk (Danzig)', 'Ind. before 1939', '0','',''),
 (208, 'Andhra Pradesh', 'India', '0','IN',''),
 (209, 'Delhi', 'India', '0','IN',''),
 (210, 'Gujarat', 'India', '0','IN',''),
 (211, 'Haryana', 'India', '0','IN',''),
 (212, 'India', 'India', '0','IN',''),
 (213, 'Karnataka', 'India', '0','IN',''),
 (214, 'Kerala', 'India', '0','IN',''),
 (215, 'Madhya Pradesh', 'India', '0','IN',''),
 (216, 'Maharashtra', 'India', '0','IN',''),
 (217, 'Orissa', 'India', '0','IN',''),
 (218, 'Punjab', 'India', '0','IN',''),
 (219, 'Rajastan', 'India', '0','IN',''),
 (220, 'Tamil Nadu', 'India', '0','IN',''),
 (221, 'Uttar Pradesh', 'India', '0','IN',''),
 (222, 'West Bengal', 'India', '0','IN',''),
 (223, 'Bali', 'Indonesia', '0','ID',''),
 (224, 'Bangka', 'Indonesia', '0','ID',''),
 (225, 'Belitung', 'Indonesia', '0','ID',''),
 (226, 'Borneo (Kalimantan)', 'Indonesia', '0','ID',''),
 (227, 'Buru', 'Indonesia', '0','ID',''),
 (228, 'Flores', 'Indonesia', '0','ID',''),
 (229, 'Halmahera', 'Indonesia', '0','ID',''),
 (230, 'Indonesia', 'Indonesia', '0','ID',''),
 (231, 'Jawa (Java)', 'Indonesia', '0','ID',''),
 (232, 'Kabaena', 'Indonesia', '0','ID',''),
 (233, 'Kepulauan Alor (Pulau Alor)', 'Indonesia', '0','ID',''),
 (234, 'Kepulauan Anambas', 'Indonesia', '0','ID',''),
 (235, 'Kepulauan Aru', 'Indonesia', '0','ID',''),
 (236, 'Kepulauan Banda', 'Indonesia', '0','ID',''),
 (237, 'Kepulauan Banggai', 'Indonesia', '0','ID',''),
 (238, 'Kepulauan Batu', 'Indonesia', '0','ID',''),
 (239, 'Kepulauan Bowokan', 'Indonesia', '0','ID',''),
 (240, 'Kepulauan Bunguran Selatan', 'Indonesia', '0','ID',''),
 (241, 'Kepulauan Bunguran Utara', 'Indonesia', '0','ID',''),
 (242, 'Kepulauan Kai', 'Indonesia', '0','ID',''),
 (243, 'Kepulauan Kangean', 'Indonesia', '0','ID',''),
 (244, 'Kepulauan Leti', 'Indonesia', '0','ID',''),
 (245, 'Kepulauan Lingga', 'Indonesia', '0','ID',''),
 (246, 'Kepulauan Mentawai', 'Indonesia', '0','ID',''),
 (247, 'Kepulauan Sangihe', 'Indonesia', '0','ID',''),
 (248, 'Kepulauan Schouten', 'Indonesia', '0','ID',''),
 (249, 'Kepulauan Tanimbar', 'Indonesia', '0','ID',''),
 (250, 'Kepulauan Togian', 'Indonesia', '0','ID',''),
 (251, 'Kepulauan Tukangbesi', 'Indonesia', '0','ID',''),
 (252, 'Lombok', 'Indonesia', '0','ID',''),
 (253, 'Madura', 'Indonesia', '0','ID',''),
 (254, 'Maluku', 'Indonesia', '0','ID',''),
 (255, 'Muna', 'Indonesia', '0','ID',''),
 (256, 'New Guinea (Irian Jaya)', 'Indonesia', '0','ID',''),
 (257, 'Pulau Babar', 'Indonesia', '0','ID',''),
 (258, 'Pulau Bacan', 'Indonesia', '0','ID',''),
 (259, 'Pulau Bawean', 'Indonesia', '0','ID',''),
 (260, 'Pulau Bengkalis', 'Indonesia', '0','ID',''),
 (261, 'Pulau Bintan', 'Indonesia', '0','ID',''),
 (262, 'Pulau Butung', 'Indonesia', '0','ID',''),
 (263, 'Pulau Damar', 'Indonesia', '0','ID',''),
 (264, 'Pulau Enggano', 'Indonesia', '0','ID',''),
 (265, 'Pulau Kalao', 'Indonesia', '0','ID',''),
 (266, 'Pulau Kundur', 'Indonesia', '0','ID',''),
 (267, 'Pulau Laut', 'Indonesia', '0','ID',''),
 (268, 'Pulau Lomblen', 'Indonesia', '0','ID',''),
 (269, 'Pulau Misool', 'Indonesia', '0','ID',''),
 (270, 'Pulau Nias', 'Indonesia', '0','ID',''),
 (271, 'Pulau Obi', 'Indonesia', '0','ID',''),
 (272, 'Pulau Padang', 'Indonesia', '0','ID',''),
 (273, 'Pulau Pantar', 'Indonesia', '0','ID',''),
 (274, 'Pulau Rangsang', 'Indonesia', '0','ID',''),
 (275, 'Pulau Rupat', 'Indonesia', '0','ID',''),
 (276, 'Pulau Sebangka', 'Indonesia', '0','ID',''),
 (277, 'Pulau Seleyar (Salayar)', 'Indonesia', '0','ID',''),
 (278, 'Pulau Siberut', 'Indonesia', '0','ID',''),
 (279, 'Pulau Simeulue', 'Indonesia', '0','ID',''),
 (280, 'Pulau Singkep', 'Indonesia', '0','ID',''),
 (281, 'Pulau Tanahjampea', 'Indonesia', '0','ID',''),
 (282, 'Pulau Tebingtinggi', 'Indonesia', '0','ID',''),
 (283, 'Pulau Waigeo', 'Indonesia', '0','ID',''),
 (284, 'Pulau Wowoni', 'Indonesia', '0','ID',''),
 (285, 'Pulau Yapen', 'Indonesia', '0','ID',''),
 (286, 'Salawati', 'Indonesia', '0','ID',''),
 (287, 'Seram (Ceram)', 'Indonesia', '0','ID',''),
 (288, 'Sulawesi (Celebes)', 'Indonesia', '0','ID',''),
 (289, 'Sumatera (Sumatra)', 'Indonesia', '0','ID',''),
 (290, 'Sumba', 'Indonesia', '0','ID',''),
 (291, 'Sumbawa', 'Indonesia', '0','ID',''),
 (292, 'Timor (Timur)', 'Indonesia', '0','ID',''),
 (293, 'Iran', 'Iran', '0','IR',''),
 (294, 'Iraq', 'Iraq', '0','IQ',''),
 (295, 'Ireland', 'Ireland', '1','IE',''),
 (296, 'Isle-of-Man', 'Isle-of-Man', '0','IM',''),
 (297, 'Golan Heights', 'Israel', '0','IL',''),
 (298, 'Israel', 'Israel', '0','IL',''),
 (299, 'Italy', 'Italy', '1','IT',''),
 (300, 'Jamaica', 'Jamaica', '0','JM',''),
 (301, 'Japan', 'Japan', '0','JP',''),
 (302, 'Mie', 'Japan', '0','JP',''),
 (303, 'Shizuoka', 'Japan', '0','JP',''),
 (304, 'Toyama', 'Japan', '0','JP',''),
 (305, 'Jordan', 'Jordan', '0','JO',''),
 (306, 'Kazakhstan', 'Kazakhstan', '0','KZ',''),
 (307, 'Kenya', 'Kenya', '0','KE',''),
 (308, 'Abemama Island', 'Kiribati', '0','KI',''),
 (309, 'Arorae Island', 'Kiribati', '0','KI',''),
 (310, 'Banaba Island', 'Kiribati', '0','KI',''),
 (311, 'Beru Island', 'Kiribati', '0','KI',''),
 (312, 'Birnie Island', 'Kiribati', '0','KI',''),
 (313, 'Canton Island', 'Kiribati', '0','KI',''),
 (314, 'Caroline Atoll', 'Kiribati', '0','KI',''),
 (315, 'Christmas Island', 'Kiribati', '0','KI',''),
 (316, 'Enderbury Island', 'Kiribati', '0','KI',''),
 (317, 'Fanning Island', 'Kiribati', '0','KI',''),
 (318, 'Filippo Reef', 'Kiribati', '0','KI',''),
 (319, 'Flint Island', 'Kiribati', '0','KI',''),
 (320, 'Gardner Island', 'Kiribati', '0','KI',''),
 (321, 'Hull Island', 'Kiribati', '0','KI',''),
 (322, 'Kiritimati(Christmas) Is', 'Kiribati', '0','KI',''),
 (323, 'Kuria Island', 'Kiribati', '0','KI',''),
 (324, 'Makin Island', 'Kiribati', '0','KI',''),
 (325, 'Malden Island', 'Kiribati', '0','KI',''),
 (326, 'Merlin Seamount', 'Kiribati', '0','KI',''),
 (327, 'Nikunau Island', 'Kiribati', '0','KI',''),
 (328, 'Nonouti Island', 'Kiribati', '0','KI',''),
 (329, 'Onotoa Island', 'Kiribati', '0','KI',''),
 (330, 'Phoenix Island', 'Kiribati', '0','KI',''),
 (331, 'Starbuck Island', 'Kiribati', '0','KI',''),
 (332, 'Sydney Island', 'Kiribati', '0','KI',''),
 (333, 'Tabiteuea Island', 'Kiribati', '0','KI',''),
 (334, 'Tamana Island', 'Kiribati', '0','KI',''),
 (335, 'Tapeteuea Island', 'Kiribati', '0','KI',''),
 (336, 'Tarawa Island', 'Kiribati', '0','KI',''),
 (337, 'Vostok Island', 'Kiribati', '0','KI',''),
 (338, 'Washington Island', 'Kiribati', '0','KI',''),
 (339, 'Korea-(Peoples-Republic-of)', 'Korea-(Peoples-Republic-of)', '0','KP',''),
 (340, 'Korea-(Republic-of)', 'Korea-(Republic-of)', '0','KR',''),
 (341, 'Kuwait', 'Kuwait', '0','KW',''),
 (342, 'Kyrgyzstan', 'Kyrgyzstan', '0','KG',''),
 (343, 'Laos', 'Laos', '0','LA',''),
 (344, 'Latvia', 'Latvia', '1','LV',''),
 (345, 'Lebanon', 'Lebanon', '0','LB',''),
 (346, 'Lesotho', 'Lesotho', '0','LS',''),
 (347, 'Liberia', 'Liberia', '0','LR',''),
 (348, 'Libya', 'Libya', '0','LY',''),
 (349, 'Liechtenstein', 'Liechtenstein', '0','LI',''),
 (350, 'Lithuania', 'Lithuania', '1','LT',''),
 (351, 'Luxembourg', 'Luxembourg', '1','LU',''),
 (352, 'Macau', 'Macau', '0','MO',''),
 (353, 'Macedonia', 'Macedonia', '0','MK',''),
 (354, 'Madagascar', 'Madagascar', '0','MG',''),
 (355, 'Malawi', 'Malawi', '0','MW',''),
 (356, 'Labuan', 'Malaysia', '0','MY',''),
 (357, 'Malaya', 'Malaysia', '0','MY',''),
 (358, 'Malaysia', 'Malaysia', '0','MY',''),
 (359, 'Sarawak', 'Malaysia', '0','MY',''),
 (360, 'Maldives', 'Maldives', '0','MV',''),
 (361, 'Mali', 'Mali', '0','ML',''),
 (362, 'Malta', 'Malta', '1','MT',''),
 (363, 'Marshall-Islands', 'Marshall-Islands', '0','MH',''),
 (364, 'Martinique', 'Martinique', '0','MQ',''),
 (365, 'Mauritius', 'Mauritius', '0','MU',''),
 (366, 'Mayotte', 'Mayotte', '0','YT',''),
 (367, 'Aguascalientes', 'Mexico', '0','MX',''),
 (368, 'Baja California Norte', 'Mexico', '0','MX',''),
 (369, 'Baja California Sur', 'Mexico', '0','MX',''),
 (370, 'Campeche', 'Mexico', '0','MX',''),
 (371, 'Chiapas', 'Mexico', '0','MX',''),
 (372, 'Chihuahua', 'Mexico', '0','MX',''),
 (373, 'Coahuila', 'Mexico', '0','MX',''),
 (374, 'Coalima', 'Mexico', '0','MX',''),
 (375, 'District Federal', 'Mexico', '0','MX',''),
 (376, 'Durango', 'Mexico', '0','MX',''),
 (377, 'Guanajuato', 'Mexico', '0','MX',''),
 (378, 'Guerrero', 'Mexico', '0','MX',''),
 (379, 'Hidalgo', 'Mexico', '0','MX',''),
 (380, 'Jalisco', 'Mexico', '0','MX',''),
 (381, 'Mexico', 'Mexico', '0','MX',''),
 (382, 'Morelos', 'Mexico', '0','MX',''),
 (383, 'Nayarit', 'Mexico', '0','MX',''),
 (384, 'Oaxaca', 'Mexico', '0','MX',''),
 (385, 'Puebla', 'Mexico', '0','MX',''),
 (386, 'Quintana Roo', 'Mexico', '0','MX',''),
 (387, 'Sinaloa', 'Mexico', '0','MX',''),
 (388, 'Sonora', 'Mexico', '0','MX',''),
 (389, 'Tabasco', 'Mexico', '0','MX',''),
 (390, 'Tamaulipas', 'Mexico', '0','MX',''),
 (391, 'Tlaxcala', 'Mexico', '0','MX',''),
 (392, 'Veracruz', 'Mexico', '0','MX',''),
 (393, 'Yucatan', 'Mexico', '0','MX',''),
 (394, 'Zacatecas', 'Mexico', '0','MX',''),
 (395, 'Moldavia', 'Moldavia', '0','MD',''),
 (396, 'Monaco', 'Monaco', '0','MC',''),
 (397, 'Mongolia', 'Mongolia', '0','',''),
 (398, 'Montenegro', 'Montenegro', '0','ME',''),
 (399, 'Montserrat', 'Montserrat', '0','MS',''),
 (400, 'Morocco', 'Morocco', '0','MA',''),
 (401, 'Sidi Ifni (since 1969)', 'Morocco', '0','MA',''),
 (402, 'Spanish Morocco', 'Morocco', '0','MA',''),
 (403, 'Tangier (since 1956)', 'Morocco', '0','MA',''),
 (404, 'Mozambique', 'Mozambique', '0','MZ',''),
 (405, 'Myanmar', 'Myanmar', '0','MM',''),
 (406, 'Namibia', 'Namibia', '0','NA',''),
 (407, 'Nauru', 'Nauru', '0','NR',''),
 (408, 'Nepal', 'Nepal', '0','NP',''),
 (409, 'Netherlands', 'Netherlands', '1','NL',''),
 (410, 'Aruba Island', 'Netherlands-Antilles', '0','AN',''),
 (411, 'Bonaire Island', 'Netherlands-Antilles', '0','AN',''),
 (412, 'Cura ao Island', 'Netherlands-Antilles', '0','AN',''),
 (413, 'Saba Island', 'Netherlands-Antilles', '0','AN',''),
 (414, 'Sint Maarten Island', 'Netherlands-Antilles', '0','AN',''),
 (415, 'Hunter Island', 'New-Caledonia', '0','NC',''),
 (416, 'New Caledonia Island', 'New-Caledonia', '0','NC',''),
 (417, 'New-Caledonia', 'New-Caledonia', '0','NC',''),
 (418, 'Arapawa Island', 'New-Zealand', '0','NZ',''),
 (419, 'Campbell Island', 'New-Zealand', '0','NZ',''),
 (420, 'New-Zealand', 'New-Zealand', '0','NZ',''),
 (421, 'Nicaragua', 'Nicaragua', '0','NI',''),
 (422, 'Niger', 'Niger', '0','NE',''),
 (423, 'Nigeria', 'Nigeria', '0','NG',''),
 (424, 'Niue', 'Niue', '0','NU',''),
 (425, 'Norfolk-Island', 'Norfolk-Island', '0','NF',''),
 (426, 'Northern-Mariana-Islands', 'Northern-Mariana-Islands', '0','MP',''),
 (427, 'Aker-Shus', 'Norway', '0','NO',''),
 (428, 'Norway', 'Norway', '0','NO',''),
 (429, 'Oman', 'Oman', '0','OM',''),
 (430, 'Baluchistan', 'Pakistan', '0','PK',''),
 (431, 'Nothern Areas', 'Pakistan', '0','PK',''),
 (432, 'Pakistan', 'Pakistan', '0','PK',''),
 (433, 'Palau', 'Palau', '0','PW',''),
 (434, 'Panama', 'Panama', '0','PA',''),
 (435, 'Bismark Islands', 'Papua-New-Guinea', '0','PG',''),
 (436, 'Bougainville', 'Papua-New-Guinea', '0','PG',''),
 (437, 'd Entrecasteaux Islands', 'Papua-New-Guinea', '0','PG',''),
 (438, 'Feni Islands', 'Papua-New-Guinea', '0','PG',''),
 (439, 'Green Islands', 'Papua-New-Guinea', '0','PG',''),
 (440, 'Hermit Islands', 'Papua-New-Guinea', '0','PG',''),
 (441, 'Kaniet Islands', 'Papua-New-Guinea', '0','PG',''),
 (442, 'Lihir Islands', 'Papua-New-Guinea', '0','PG',''),
 (443, 'Louisiade Islands', 'Papua-New-Guinea', '0','PG',''),
 (444, 'Manus Island', 'Papua-New-Guinea', '0','PG',''),
 (445, 'Mussau Island', 'Papua-New-Guinea', '0','PG',''),
 (446, 'New Britain', 'Papua-New-Guinea', '0','PG',''),
 (447, 'New Guinea', 'Papua-New-Guinea', '0','PG',''),
 (448, 'New Hanover Island', 'Papua-New-Guinea', '0','PG',''),
 (449, 'New Ireland', 'Papua-New-Guinea', '0','PG',''),
 (450, 'Ninigo Islands', 'Papua-New-Guinea', '0','PG',''),
 (451, 'Nuguria Islands', 'Papua-New-Guinea', '0','PG',''),
 (452, 'Nukumanu Islands', 'Papua-New-Guinea', '0','PG',''),
 (453, 'Rossel Island', 'Papua-New-Guinea', '0','PG',''),
 (454, 'Tabar Islands', 'Papua-New-Guinea', '0','PG',''),
 (455, 'Tagula Island', 'Papua-New-Guinea', '0','PG',''),
 (456, 'Tanga Islands', 'Papua-New-Guinea', '0','PG',''),
 (457, 'Tauu Islands', 'Papua-New-Guinea', '0','PG',''),
 (458, 'Trobriand Island', 'Papua-New-Guinea', '0','PG',''),
 (459, 'Woodlark Island', 'Papua-New-Guinea', '0','PG',''),
 (460, 'Wuvulu Island', 'Papua-New-Guinea', '0','PG',''),
 (461, 'Paraguay', 'Paraguay', '0','PY',''),
 (462, 'Peru', 'Peru', '0','PE',''),
 (463, 'Philippines', 'Philippines', '0','PH',''),
 (464, 'Pitcairn', 'Pitcairn', '0','PN',''),
 (465, 'Austrian before 1918', 'Poland', '1','PL',''),
 (466, 'German (Prussian) before 1918', 'Poland', '1','PL',''),
 (467, 'German (Prussian) before 1944', 'Poland', '1','PL',''),
 (468, 'Poland', 'Poland', '1','PL',''),
 (469, 'Azores', 'Portugal', '0','PT',''),
 (470, 'Madeira Islands', 'Portugal', '0','PT',''),
 (471, 'Mainland Portugal', 'Portugal', '0','PT',''),
 (472, 'Portugal', 'Portugal', '1','PT',''),
 (473, 'Puerto-Rico', 'Puerto-Rico', '0','PR',''),
 (474, 'Qatar', 'Qatar', '0','QA',''),
 (475, 'Reunion', 'Reunion', '0','RE',''),
 (476, 'Romania', 'Romania', '1','RO',''),
 (477, 'Asian RSFSR', 'Russian-Federation', '0','RU',''),
 (478, 'European RSFSR', 'Russian-Federation', '0','RU',''),
 (479, 'Kaliningrad area', 'Russian-Federation', '0','RU',''),
 (480, 'Komandorskije Ostrova', 'Russian-Federation', '0','RU',''),
 (481, 'Kuril Islands', 'Russian-Federation', '0','RU',''),
 (482, 'Novaja Zeml area', 'Russian-Federation', '0','RU',''),
 (483, 'Novosibirskije Ostrova', 'Russian-Federation', '0','RU',''),
 (484, 'Ostrov Sachalin', 'Russian-Federation', '0','RU',''),
 (485, 'Russian-Federation', 'Russian-Federation', '0','RU',''),
 (486, 'Severnaja Zeml area', 'Russian-Federation', '0','RU',''),
 (487, 'Rwanda', 'Rwanda', '0','RW',''),
 (488, 'Bequia Island', 'Saint-Vincent-and-the-Grenadin', '0','VC',''),
 (489, 'Canouan Island', 'Saint-Vincent-and-the-Grenadin', '0','VC',''),
 (490, 'Carriacou Island', 'Saint-Vincent-and-the-Grenadin', '0','VC',''),
 (491, 'Saint Vincent Island', 'Saint-Vincent-and-the-Grenadin', '0','VC',''),
 (492, 'San-Marino', 'San-Marino', '0','SM',''),
 (493, 'Sao-Tome-and-Principe', 'Sao-Tome-and-Principe', '0','ST',''),
 (494, 'Saudi-Arabia', 'Saudi-Arabia', '0','SA',''),
 (495, 'Senegal', 'Senegal', '0','SN',''),
 (496, 'Serbia', 'Serbia', '0','RS',''),
 (497, 'Seychelles', 'Seychelles', '0','SC',''),
 (498, 'Sierra-Leone', 'Sierra-Leone', '0','SL',''),
 (499, 'Singapore', 'Singapore', '0','SG',''),
 (500, 'Slovakia', 'Slovakia', '1','SK',''),
 (501, 'Slovenia', 'Slovenia', '1','SI',''),
 (502, 'Choiseul', 'Solomon-Islands', '0','SB',''),
 (503, 'Guadalcanal', 'Solomon-Islands', '0','SB',''),
 (504, 'Malaita', 'Solomon-Islands', '0','SB',''),
 (505, 'New Georgia', 'Solomon-Islands', '0','SB',''),
 (506, 'San Cristobal', 'Solomon-Islands', '0','SB',''),
 (507, 'Santa Isabel', 'Solomon-Islands', '0','SB',''),
 (508, 'Somalia', 'Somalia', '0','SO',''),
 (509, 'Eastern Cape', 'South-Africa', '0','ZA',''),
 (510, 'Kwazulu-Natal', 'South-Africa', '0','ZA',''),
 (511, 'Mpumalanga', 'South-Africa', '0','ZA',''),
 (512, 'South-Africa', 'South-Africa', '0','ZA',''),
 (513, 'South-Georgia', 'South-Georgia', '0','',''),
 (514, 'Balearic Islands', 'Spain', '0','ES',''),
 (515, 'Canary Islands', 'Spain', '1','ES',''),
 (516, 'Mainland', 'Spain', '1','ES',''),
 (517, 'Spain', 'Spain', '1','ES',''),
 (518, 'Spanish Morocco', 'Spain', '1','ES',''),
 (519, 'Sri-Lanka', 'Sri-Lanka', '0','LK',''),
 (520, 'St.-Kitts-and-Nevis', 'St.-Kitts-and-Nevis', '0','KN',''),
 (521, 'St.-Lucia', 'St.-Lucia', '0','LC',''),
 (522, 'St.-Pierre-and-Miquelon', 'St.-Pierre-and-Miquelon', '0','PM',''),
 (523, 'Sudan', 'Sudan', '0','SD',''),
 (524, 'Suriname', 'Suriname', '0','SR',''),
 (525, 'Swaziland', 'Swaziland', '0','SZ',''),
 (526, 'Sweden', 'Sweden', '1','SE',''),
 (527, 'Switzerland', 'Switzerland', '0','CH',''),
 (528, 'Syrian-Arab-Republic', 'Syrian-Arab-Republic', '0','SY',''),
 (529, 'Taiwan', 'Taiwan', '0','TW',''),
 (530, 'Tajikistan', 'Tajikistan', '0','TJ',''),
 (531, 'Tanzania', 'Tanzania', '0','TZ',''),
 (532, 'Thailand', 'Thailand', '0','TH',''),
 (533, 'The-Gambia', 'The-Gambia', '0','GM',''),
 (534, 'Togo', 'Togo', '0','TG',''),
 (535, 'Tokelau', 'Tokelau', '0','TK',''),
 (536, 'Ata Island', 'Tonga', '0','TO',''),
 (537, 'Eua Island', 'Tonga', '0','TO',''),
 (538, 'Tafahi Island', 'Tonga', '0','TO',''),
 (539, 'Toku Island', 'Tonga', '0','TO',''),
 (540, 'Tongatapu Islands', 'Tonga', '0','TO',''),
 (541, 'Vava u Islands', 'Tonga', '0','TO',''),
 (542, 'Tobago', 'Trinidad-and-Tobago', '0','TT',''),
 (543, 'Trinidad', 'Trinidad-and-Tobago', '0','TT',''),
 (544, 'Trinidad-and-Tobago', 'Trinidad-and-Tobago', '0','TT',''),
 (545, 'Tunisia', 'Tunisia', '0','TN',''),
 (546, 'Asian', 'Turkey', '0','TR',''),
 (547, 'European', 'Turkey', '0','TR',''),
 (548, 'Turkey', 'Turkey', '0','TR',''),
 (549, 'Turkmenistan', 'Turkmenistan', '0','TM',''),
 (550, 'Turks-and-Caicos-Islands', 'Turks-and-Caicos-Islands', '0','TC',''),
 (551, 'Tuvalu', 'Tuvalu', '0','TV',''),
 (552, 'Uganda', 'Uganda', '0','UG',''),
 (553, 'Ukraine', 'Ukraine', '0','UA',''),
 (554, 'United-Arab-Emirates', 'United-Arab-Emirates', '0','AE',''),
 (555, 'Alabama', 'United-States', '0','US','AL'),
 (556, 'Alaska', 'United-States', '0','US','AK'),
 (557, 'Arizona', 'United-States', '0','US','AZ'),
 (558, 'Arkansas', 'United-States', '0','US','AR'),
 (559, 'California', 'United-States', '0','US','CA'),
 (560, 'Colorado', 'United-States', '0','US','CO'),
 (561, 'Connecticut', 'United-States', '0','US','CT'),
 (562, 'Delaware', 'United-States', '0','US','DE'),
 (563, 'District of Columbia', 'United-States', '0','US','DC'),
 (564, 'Florida', 'United-States', '0','US','FL'),
 (565, 'Georgia', 'United-States', '0','US','GA'),
 (566, 'Hawaii', 'United-States', '0','US','HI'),
 (567, 'Idaho', 'United-States', '0','US','ID'),
 (568, 'Illinois', 'United-States', '0','US','IL'),
 (569, 'Indiana', 'United-States', '0','US','IN'),
 (570, 'Iowa', 'United-States', '0','US','IA'),
 (571, 'Kansas', 'United-States', '0','US','KS'),
 (572, 'Kentucky', 'United-States', '0','US','KY'),
 (573, 'Louisiana', 'United-States', '0','US','LA'),
 (574, 'Maine', 'United-States', '0','US','ME'),
 (575, 'Maryland', 'United-States', '0','US','MD'),
 (576, 'Massachusetts', 'United-States', '0','US','MA'),
 (577, 'Michigan', 'United-States', '0','US','MI'),
 (578, 'Minnesota', 'United-States', '0','US','MN'),
 (579, 'Mississippi', 'United-States', '0','US','MS'),
 (580, 'Missouri', 'United-States', '0','US','MO'),
 (581, 'Montana', 'United-States', '0','US','MT'),
 (582, 'Nebraska', 'United-States', '0','US','NE'),
 (583, 'Nevada', 'United-States', '0','US','NV'),
 (584, 'New Hampshire', 'United-States', '0','US','NH'),
 (585, 'New Jersey', 'United-States', '0','US','NJ'),
 (586, 'New Mexico', 'United-States', '0','US','NM'),
 (587, 'New York', 'United-States', '0','US','NY'),
 (588, 'North Carolina', 'United-States', '0','US','NC'),
 (589, 'North Dakota', 'United-States', '0','US','ND'),
 (590, 'Ohio', 'United-States', '0','US','OH'),
 (591, 'Oklahoma', 'United-States', '0','US','OK'),
 (592, 'Oregon', 'United-States', '0','US','OR'),
 (593, 'Pennsylvania', 'United-States', '0','US','PA'),
 (594, 'Rhode Island', 'United-States', '0','US','RI'),
 (595, 'South Carolina', 'United-States', '0','US','SC'),
 (596, 'South Dakota', 'United-States', '0','US','SD'),
 (597, 'Tennessee', 'United-States', '0','US','TN'),
 (598, 'Texas', 'United-States', '0','US','TX'),
 (599, 'United-States', 'United-States', '0','US',''),
 (600, 'Utah', 'United-States', '0','US','UT'),
 (601, 'Vermont', 'United-States', '0','US','VT'),
 (602, 'Virginia', 'United-States', '0','US','VA'),
 (603, 'Washington', 'United-States', '0','US','WA'),
 (604, 'West Virginia', 'United-States', '0','US','WV'),
 (605, 'Wisconsin', 'United-States', '0','US','WI'),
 (606, 'Wyoming', 'United-States', '0','US','WY'),
 (607, 'Uruguay', 'Uruguay', '0','UY',''),
 (608, 'Uzbekistan', 'Uzbekistan', '0','UZ',''),
 (609, 'Ambrim Island', 'Vanuatu', '0','VU',''),
 (610, 'Aneityum Island', 'Vanuatu', '0','VU',''),
 (611, 'Efate Island', 'Vanuatu', '0','VU',''),
 (612, 'Epi Island', 'Vanuatu', '0','VU',''),
 (613, 'Eromanga Island', 'Vanuatu', '0','VU',''),
 (614, 'Espritu Santo Island', 'Vanuatu', '0','VU',''),
 (615, 'Maewo Island', 'Vanuatu', '0','VU',''),
 (616, 'Malekula Island', 'Vanuatu', '0','VU',''),
 (617, 'Oba Island', 'Vanuatu', '0','VU',''),
 (618, 'Pentecost Island', 'Vanuatu', '0','VU',''),
 (619, 'Santa Maria Island', 'Vanuatu', '0','VU',''),
 (620, 'Tana Island', 'Vanuatu', '0','VU',''),
 (621, 'Torres Islands', 'Vanuatu', '0','VU',''),
 (622, 'Vanua Lava Island', 'Vanuatu', '0','VU',''),
 (623, 'Vanuatu', 'Vanuatu', '0','VU',''),
 (624, 'Venezuela', 'Venezuela', '0','VE',''),
 (625, 'North Vietnam', 'Viet-Nam', '0','VN',''),
 (626, 'South Vietnam', 'Viet-Nam', '0','VN',''),
 (627, 'Viet-Nam', 'Viet-Nam', '0','VN',''),
 (628, 'Virgin-Islands-(U.K.)', 'Virgin-Islands-(U.K.)', '0','',''),
 (629, 'Virgin-Islands-(U.S.)', 'Virgin-Islands-(U.S.)', '0','VI',''),
 (630, 'Wallis-and-Futanu-Islands', 'Wallis-and-Futanu-Islands', '0','WF',''),
 (631, 'Savai i', 'Western-Samoa', '0','',''),
 (632, 'Upolu', 'Western-Samoa', '0','',''),
 (633, 'Yemen', 'Yemen', '0','YE',''),
 (634, 'Yugoslavia', 'Yugoslavia', '0','YU',''),
 (635, 'Zaire', 'Zaire', '0','ZR',''),
 (636, 'Zambia', 'Zambia', '0','ZM',''),
 (637, 'Zimbabwe', 'Zimbabwe', '0','ZW',''),
 (638, 'Bedfordshire', 'UK-England', '1','UK',''),
 (639, 'Berkshire', 'UK-England', '1','UK',''),
 (640, 'Buckinghamshire', 'UK-England', '1','UK',''),
 (641, 'Cambridgeshire', 'UK-England', '1','UK',''),
 (642, 'Cheshire', 'UK-England', '1','UK',''),
 (643, 'Cornwall', 'UK-England', '1','UK',''),
 (644, 'Cumberland', 'UK-England', '1','UK',''),
 (645, 'Derbyshire', 'UK-England', '1','UK',''),
 (646, 'Devon', 'UK-England', '1','UK',''),
 (647, 'Dorset', 'UK-England', '1','UK',''),
 (648, 'Durham', 'UK-England', '1','UK',''),
 (649, 'Essex', 'UK-England', '1','UK',''),
 (650, 'Gloucestershire', 'UK-England', '1','UK',''),
 (651, 'Hampshire', 'UK-England', '1','UK',''),
 (652, 'Herefordshire', 'UK-England', '1','UK',''),
 (653, 'Hertfordshire', 'UK-England', '1','UK',''),
 (654, 'Huntingdonshire', 'UK-England', '1','UK',''),
 (655, 'Kent', 'UK-England', '1','UK',''),
 (656, 'Lancashire', 'UK-England', '1','UK',''),
 (657, 'Leicestershire', 'UK-England', '1','UK',''),
 (658, 'Lincolnshire', 'UK-England', '1','UK',''),
 (659, 'Middlesex', 'UK-England', '1','UK',''),
 (660, 'Norfolk', 'UK-England', '1','UK',''),
 (661, 'Northamptonshire', 'UK-England', '1','UK',''),
 (662, 'Northumberland', 'UK-England', '1','UK',''),
 (663, 'Nottinghamshire', 'UK-England', '1','UK',''),
 (664, 'Oxfordshire', 'UK-England', '1','UK',''),
 (665, 'Rutland', 'UK-England', '1','UK',''),
 (666, 'Shropshire', 'UK-England', '1','UK',''),
 (667, 'Somerset', 'UK-England', '1','UK',''),
 (668, 'Staffordshire', 'UK-England', '1','UK',''),
 (669, 'Suffolk', 'UK-England', '1','UK',''),
 (670, 'Surrey', 'UK-England', '1','UK',''),
 (671, 'Sussex', 'UK-England', '1','UK',''),
 (672, 'Warwickshire', 'UK-England', '1','UK',''),
 (673, 'Westmorland', 'UK-England', '1','UK',''),
 (674, 'Wiltshire', 'UK-England', '1','UK',''),
 (675, 'Worcestershire', 'UK-England', '1','UK',''),
 (676, 'Yorkshire', 'UK-England', '1','UK',''),
 (677, 'Anglesey-Sir Fon', 'UK-Wales(inc. Monmouthshire)', '1','UK',''),
 (678, 'Brecknockshire-Sir Frycheiniog', 'UK-Wales(inc. Monmouthshire)', '1','UK',''),
 (679, 'Caernarfonshire-Sir Gaernarfon', 'UK-Wales(inc. Monmouthshire)', '1','UK',''),
 (680, 'Carmarthenshire-Sir Gaerfyrddin', 'UK-Wales(inc. Monmouthshire)', '1','UK',''),
 (681, 'Cardiganshire-Ceredigion', 'UK-Wales(inc. Monmouthshire)', '1','UK',''),
 (682, 'Denbighshire-Sir Ddinbych', 'UK-Wales(inc. Monmouthshire)', '1','UK',''),
 (683, 'Flintshire-Sir Fflint', 'UK-Wales(inc. Monmouthshire)', '1','UK',''),
 (684, 'Glamorgan-Morgannwg', 'UK-Wales(inc. Monmouthshire)', '1','UK',''),
 (685, 'Merioneth-Meirionnydd', 'UK-Wales(inc. Monmouthshire)', '1','UK',''),
 (686, 'Monmouthshire-Sir Fynwy', 'UK-Wales(inc. Monmouthshire)', '1','UK',''),
 (687, 'Montgomeryshire-Sir Drefaldwyn', 'UK-Wales(inc. Monmouthshire)', '1','UK',''),
 (688, 'Pembrokeshire-Sir Benfro', 'UK-Wales(inc. Monmouthshire)', '1','UK',''),
 (689, 'Radnorshire-Sir Faesyfed', 'UK-Wales(inc. Monmouthshire)', '1','UK',''),
 (690, 'Aberdeenshire', 'UK-Scotland', '1','UK',''),
 (691, 'Angus-Forfarshire', 'UK-Scotland', '1','UK',''),
 (692, 'Argyllshire', 'UK-Scotland', '1','UK',''),
 (693, 'Ayrshire', 'UK-Scotland', '1','UK',''),
 (694, 'Banffshire', 'UK-Scotland', '1','UK',''),
 (695, 'Berwickshire', 'UK-Scotland', '1','UK',''),
 (696, 'Buteshire', 'UK-Scotland', '1','UK',''),
 (697, 'Cromartyshire', 'UK-Scotland', '1','UK',''),
 (698, 'Caithness', 'UK-Scotland', '1','UK',''),
 (699, 'Clackmannanshire', 'UK-Scotland', '1','UK',''),
 (700, 'Dumfriesshire', 'UK-Scotland', '1','UK',''),
 (701, 'Dunbartonshire-Dumbartonshire', 'UK-Scotland', '1','UK',''),
 (702, 'East Lothian-Haddingtonshire', 'UK-Scotland', '1','UK',''),
 (703, 'Fife', 'UK-Scotland', '1','UK',''),
 (704, 'Inverness-shire', 'UK-Scotland', '1','UK',''),
 (705, 'Kincardineshire', 'UK-Scotland', '1','UK',''),
 (706, 'Kinross-shire', 'UK-Scotland', '1','UK',''),
 (707, 'Kirkcudbrightshire', 'UK-Scotland', '1','UK',''),
 (708, 'Lanarkshire', 'UK-Scotland', '1','UK',''),
 (709, 'Midlothian-Edinburghshire', 'UK-Scotland', '1','UK',''),
 (710, 'Morayshire', 'UK-Scotland', '1','UK',''),
 (711, 'Nairnshire', 'UK-Scotland', '1','UK',''),
 (712, 'Orkney', 'UK-Scotland', '1','UK',''),
 (713, 'Peeblesshire', 'UK-Scotland', '1','UK',''),
 (714, 'Perthshire', 'UK-Scotland', '1','UK',''),
 (715, 'Renfrewshire', 'UK-Scotland', '1','UK',''),
 (716, 'Ross-shire', 'UK-Scotland', '1','UK',''),
 (717, 'Roxburghshire', 'UK-Scotland', '1','UK',''),
 (718, 'Selkirkshire', 'UK-Scotland', '1','UK',''),
 (719, 'Shetland', 'UK-Scotland', '1','UK',''),
 (720, 'Stirlingshire', 'UK-Scotland', '1','UK',''),
 (721, 'Sutherland', 'UK-Scotland', '1','UK',''),
 (722, 'West Lothian-Linlithgowshire', 'UK-Scotland', '1','UK',''),
 (723, 'Wigtownshire', 'UK-Scotland', '1','UK',''),
 (724, 'Antrim', 'UK-Northern Ireland', '1','UK',''),
 (725, 'Armagh', 'UK-Northern Ireland', '1','UK',''),
 (726, 'Down', 'UK-Northern Ireland', '1','UK',''),
 (727, 'Fermanagh', 'UK-Northern Ireland', '1','UK',''),
 (728, 'Londonderry', 'UK-Northern Ireland', '1','UK',''),
 (729, 'Tyrone', 'UK-Northern Ireland', '1','UK','');


CREATE TABLE IF NOT EXISTS `#__digistore_taxplugin` (
  `pluginid` int(11) NOT NULL default '0',
  `ptypes` text NOT NULL,
  `locations` text NOT NULL
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_tax_customerclass` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(200) NOT NULL default '',
  `published` tinyint(4) NOT NULL default '0',
  `ordering` int(11) NOT NULL default '0',
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_tax_productclass` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(200) NOT NULL default '',
  `published` tinyint(4) NOT NULL default '0',
  `ordering` int(11) NOT NULL default '0',
  `checked_out` int(11) unsigned NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_tax_rate` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(250) NOT NULL default '',
  `country` varchar(200) NOT NULL default '',
  `state` varchar(200) NOT NULL default '',
  `zip` varchar(200) NOT NULL default '',
  `rate` double NOT NULL default '0',
  `published` int(11) NOT NULL default '1',
  `ordering` int(11) NOT NULL default '0',
  `checked_out` int(11) NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`),
  UNIQUE KEY `name_2` (`name`),
  UNIQUE KEY `name_3` (`name`),
  UNIQUE KEY `name_4` (`name`),
  UNIQUE KEY `name_5` (`name`),
  UNIQUE KEY `name_6` (`name`),
  UNIQUE KEY `name_7` (`name`),
  UNIQUE KEY `name_8` (`name`),
  UNIQUE KEY `name_9` (`name`),
  UNIQUE KEY `name_10` (`name`),
  UNIQUE KEY `name_11` (`name`),
  UNIQUE KEY `name_12` (`name`),
  UNIQUE KEY `name_13` (`name`),
  UNIQUE KEY `name_14` (`name`),
  UNIQUE KEY `name_15` (`name`),
  UNIQUE KEY `name_16` (`name`),
  UNIQUE KEY `name_17` (`name`),
  UNIQUE KEY `name_18` (`name`),
  UNIQUE KEY `name_19` (`name`),
  UNIQUE KEY `name_20` (`name`),
  UNIQUE KEY `name_21` (`name`),
  UNIQUE KEY `name_22` (`name`),
  UNIQUE KEY `name_23` (`name`),
  UNIQUE KEY `name_24` (`name`),
  UNIQUE KEY `name_25` (`name`),
  UNIQUE KEY `name_26` (`name`),
  UNIQUE KEY `name_27` (`name`),
  UNIQUE KEY `name_28` (`name`),
  UNIQUE KEY `name_29` (`name`),
  UNIQUE KEY `name_30` (`name`),
  UNIQUE KEY `name_31` (`name`),
  UNIQUE KEY `name_32` (`name`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `#__digistore_tax_rule` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(200) NOT NULL default '',
  `cclass` text NOT NULL,
  `pclass` text NOT NULL,
  `trate` text NOT NULL,
  `ptype` text NOT NULL,
  `published` int(11) NOT NULL default '1',
  `ordering` int(11) NOT NULL default '0',
  `checked_out` int(11) NOT NULL default '0',
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


drop table if exists `#__digistore_topleveldomains`;

CREATE TABLE IF NOT EXISTS `#__digistore_topleveldomains` (
  `tld_id` mediumint(9) NOT NULL auto_increment,
  `tld` varchar(6) NOT NULL default '',
  `fullname` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`tld_id`),
  KEY `tld` (`tld`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

INSERT IGNORE INTO `#__digistore_topleveldomains` (`tld_id`, `tld`, `fullname`) VALUES 
(1, 'ac', 'Ascension Island'),
(2, 'ac.uk', 'Education (UK)'),
(3, 'ad', 'Andorra'),
(4, 'ae', 'United Arab Emirates'),
(5, 'af', 'Afghanistan'),
(6, 'ag', 'Antigua and Barbuda'),
(7, 'ai', 'Anguilla'),
(8, 'al', 'Albania'),
(9, 'am', 'Armenia'),
(10, 'an', 'Netherlands Antilles'),
(11, 'ao', 'Angola'),
(12, 'aq', 'Antarctica'),
(13, 'ar', 'Argentina'),
(14, 'as', 'American Samoa'),
(15, 'at', 'Austria'),
(16, 'au', 'Australia'),
(17, 'aw', 'Aruba'),
(18, 'az', 'Azerbaijan'),
(19, 'ba', 'Bosnia Hercegovina'),
(20, 'bb', 'Barbados'),
(21, 'bd', 'Bangladesh'),
(22, 'be', 'Belgium'),
(23, 'bf', 'Burkina Faso'),
(24, 'bg', 'Bulgaria'),
(25, 'bh', 'Bahrain'),
(26, 'bi', 'Burundi'),
(27, 'bj', 'Benin'),
(28, 'bm', 'Bermuda'),
(29, 'bn', 'Brunei Darussalam'),
(30, 'bo', 'Bolivia'),
(31, 'br', 'Brazil'),
(32, 'bs', 'Bahamas'),
(33, 'bt', 'Bhutan'),
(34, 'bv', 'Bouvet Island'),
(35, 'bw', 'Botswana'),
(36, 'by', 'Belarus (Byelorussia)'),
(37, 'bz', 'Belize'),
(38, 'ca', 'Canada'),
(39, 'cc', 'Cocos Islands (Keeling)'),
(40, 'cd', 'Congo, Democratic Republic of the'),
(41, 'cf', 'Central African Republic'),
(42, 'cg', 'Congo, Republic of'),
(43, 'ch', 'Switzerland'),
(44, 'ci', 'Cote d''Ivoire (Ivory Coast)'),
(45, 'ck', 'Cook Islands'),
(46, 'cl', 'Chile'),
(47, 'cm', 'Cameroon'),
(48, 'cn', 'China'),
(49, 'co', 'Colombia'),
(50, 'co.uk', 'Commercial United Kingdom'),
(51, 'com', 'Commercial'),
(52, 'cr', 'Costa Rica'),
(53, 'cs', 'Czechoslovakia'),
(54, 'cu', 'Cuba'),
(55, 'cv', 'Cap Verde'),
(56, 'cx', 'Christmas Island'),
(57, 'cy', 'Cyprus'),
(58, 'cz', 'Czech Republic'),
(59, 'de', 'Germany'),
(60, 'dj', 'Djibouti'),
(61, 'dk', 'Denmark'),
(62, 'dm', 'Dominica'),
(63, 'do', 'Dominican Republic'),
(64, 'dz', 'Algeria'),
(65, 'ec', 'Ecuador'),
(66, 'edu', 'Educational Institution'),
(67, 'ee', 'Estonia'),
(68, 'eg', 'Egypt'),
(69, 'eh', 'Western Sahara'),
(70, 'er', 'Eritrea'),
(71, 'es', 'Spain'),
(72, 'et', 'Ethiopia'),
(73, 'fi', 'Finland'),
(74, 'fj', 'Fiji'),
(75, 'fk', 'Falkland Islands'),
(76, 'fm', 'Micronesia, Federal State of'),
(77, 'fo', 'Faroe Islands'),
(78, 'fr', 'France'),
(79, 'ga', 'Gabon'),
(80, 'gd', 'Grenada'),
(81, 'ge', 'Georgia'),
(82, 'gf', 'French Guiana'),
(83, 'gg', 'Guernsey'),
(84, 'gh', 'Ghana'),
(85, 'gi', 'Gibraltar'),
(86, 'gl', 'Greenland'),
(87, 'gm', 'Gambia'),
(88, 'gn', 'Guinea'),
(89, 'gov', 'Government (US)'),
(90, 'gp', 'Guadeloupe'),
(91, 'gq', 'Equatorial Guinea'),
(92, 'gr', 'Greece'),
(93, 'gs', 'South Georgia and the South Sandwich Islands'),
(94, 'gt', 'Guatemala'),
(95, 'gu', 'Guam'),
(96, 'gw', 'Guinea-Bissau'),
(97, 'gy', 'Guyana'),
(98, 'hk', 'Hong Kong'),
(99, 'hm', 'Heard and McDonald Islands'),
(100, 'hn', 'Honduras'),
(101, 'hr', 'Croatia/Hrvatska'),
(102, 'ht', 'Haiti'),
(103, 'hu', 'Hungary'),
(104, 'id', 'Indonesia'),
(105, 'ie', 'Ireland'),
(106, 'il', 'Israel'),
(107, 'im', 'Isle of Man'),
(108, 'in', 'India'),
(109, 'int', 'Int. Organizations'),
(110, 'io', 'British Indian Ocean Territory'),
(111, 'iq', 'Iraq'),
(112, 'ir', 'Iran, Islamic Republic of'),
(113, 'is', 'Iceland'),
(114, 'it', 'Italy'),
(115, 'je', 'Jersey'),
(116, 'jm', 'Jamaica'),
(117, 'jo', 'Jordan'),
(118, 'jp', 'Japan'),
(119, 'ke', 'Kenya'),
(120, 'kg', 'Kyrgyzstan'),
(121, 'kh', 'Cambodia'),
(122, 'ki', 'Kiribati'),
(123, 'km', 'Comoros'),
(124, 'kn', 'Saint Kitts and Nevis'),
(125, 'kp', 'Korea, Democratic People''s Republic'),
(126, 'kr', 'Korea, Republic of'),
(127, 'kw', 'Kuwait'),
(128, 'ky', 'Cayman Islands'),
(129, 'kz', 'Kazakhstan'),
(130, 'la', 'Lao People''s Democratic Republic'),
(131, 'lb', 'Lebanon'),
(132, 'lc', 'Saint Lucia'),
(133, 'li', 'Liechtenstein'),
(134, 'lk', 'Sri Lanka'),
(135, 'lr', 'Liberia'),
(136, 'ls', 'Lesotho'),
(137, 'lt', 'Lithuania'),
(138, 'lu', 'Luxembourg'),
(139, 'lv', 'Latvia'),
(140, 'ly', 'Libyan Arab Jamahiriya'),
(141, 'ma', 'Morocco'),
(142, 'mc', 'Monaco'),
(143, 'md', 'Moldova, Republic of'),
(144, 'mg', 'Madagascar'),
(145, 'mh', 'Marshall Islands'),
(146, 'mil', 'Military (US Dept of Defense)'),
(147, 'mk', 'Macedonia, Former Yugoslav Republic'),
(148, 'ml', 'Mali'),
(149, 'mm', 'Myanmar'),
(150, 'mn', 'Mongolia'),
(151, 'mo', 'Macau'),
(152, 'mp', 'Northern Mariana Islands'),
(153, 'mq', 'Martinique'),
(154, 'mr', 'Mauritani'),
(155, 'ms', 'Montserrat'),
(156, 'mt', 'Malta'),
(157, 'mu', 'Mauritius'),
(158, 'mv', 'Maldives'),
(159, 'mw', 'Malawi'),
(160, 'mx', 'Mexico'),
(161, 'my', 'Malaysia'),
(162, 'mz', 'Mozambique'),
(163, 'na', 'Namibia'),
(164, 'nc', 'New Caledonia'),
(165, 'ne', 'Niger'),
(166, 'net', 'networks'),
(167, 'nf', 'Norfolk Island'),
(168, 'ng', 'Nigeria'),
(169, 'ni', 'Nicaragua'),
(170, 'nl', 'Netherlands'),
(171, 'no', 'Norway'),
(172, 'np', 'Nepal'),
(173, 'nr', 'Nauru'),
(174, 'nt', 'Neutral Zone'),
(175, 'nu', 'Niue'),
(176, 'nz', 'New Zealand'),
(177, 'om', 'Oman'),
(178, 'org', 'Organization (non-profit)'),
(179, 'pa', 'Panama'),
(180, 'pe', 'Peru'),
(181, 'pf', 'French Polynesia'),
(182, 'pg', 'Papua New Guinea'),
(183, 'ph', 'Philippines'),
(184, 'pk', 'Pakistan'),
(185, 'pl', 'Poland'),
(186, 'pm', 'St. Pierre and Miquelon'),
(187, 'pn', 'Pitcairn Island'),
(188, 'pr', 'Puerto Rico'),
(189, 'ps', 'Palestinian Territories'),
(190, 'pt', 'Portugal'),
(191, 'pw', 'Palau'),
(192, 'py', 'Paraguay'),
(193, 'qa', 'Qatar'),
(194, 're', 'Reunion Island'),
(195, 'ro', 'Romania'),
(196, 'ru', 'Russian Federation'),
(197, 'rw', 'Rwanda'),
(198, 'sa', 'Saudi Arabia'),
(199, 'sb', 'Solomon Islands'),
(200, 'sc', 'Seychelles'),
(201, 'sd', 'Sudan'),
(202, 'se', 'Sweden'),
(203, 'sg', 'Singapore'),
(204, 'sh', 'St. Helena'),
(205, 'si', 'Slovenia'),
(206, 'sj', 'Svalbard and Jan Mayen Islands'),
(207, 'sk', 'Slovak Republic'),
(208, 'sl', 'Sierra Leone'),
(209, 'sm', 'San Marino'),
(210, 'sn', 'Senegal'),
(211, 'so', 'Somalia'),
(212, 'sr', 'Suriname'),
(213, 'sv', 'El Salvador'),
(214, 'st', 'Sao Tome and Principe'),
(215, 'sy', 'Syrian Arab Republic'),
(216, 'sz', 'Swaziland'),
(217, 'tc', 'Turks and Caicos Islands'),
(218, 'td', 'Chad'),
(219, 'tf', 'French Southern Territories'),
(220, 'tg', 'Togo'),
(221, 'tj', 'Tajikistan'),
(222, 'tk', 'Tokelau'),
(223, 'tm', 'Turkmenistan'),
(224, 'tn', 'Tunisia'),
(225, 'to', 'Tonga'),
(226, 'tp', 'East Timor'),
(227, 'tr', 'Turkey'),
(228, 'tt', 'Trinidad and Tobago'),
(229, 'tv', 'Tuvalu'),
(230, 'tw', 'Taiwan'),
(231, 'tz', 'Tanzania'),
(232, 'ua', 'Ukraine'),
(233, 'ug', 'Uganda'),
(234, 'uk', 'United Kingdom'),
(235, 'um', 'US Minor Outlying Islands'),
(236, 'us', 'United States'),
(237, 'uy', 'Uruguay'),
(238, 'uz', 'Uzbekistan'),
(239, 'va', 'Holy See (City Vatican State)'),
(240, 'vc', 'Saint Vincent and the Grenadines'),
(241, 've', 'Venezuela'),
(242, 'vg', 'Virgin Islands (British)'),
(243, 'vi', 'Virgin Islands (USA)'),
(244, 'vn', 'Vietnam'),
(245, 'vu', 'Vanuatu'),
(246, 'wf', 'Wallis and Futuna Islands'),
(247, 'ws', 'Western Samoa'),
(248, 'ye', 'Yemen'),
(249, 'yt', 'Mayotte'),
(250, 'yu', 'Yugoslavia'),
(251, 'za', 'South Africa'),
(252, 'zm', 'Zambia'),
(253, 'zw', 'Zimbabwe'),
(254, 'aero', 'Air-transport industry'),
(255, 'biz', 'Businesses'),
(256, 'coop', 'Cooperatives'),
(257, 'info', 'Unrestricted use'),
(258, 'museum', 'Museums'),
(259, 'name', 'Individuals'),
(260, 'pro', 'Accountants, lawyers, and physicians'),
(261, 'arpa', 'Old Style Arpanet'),
(262, 'nato', 'Nato field'),
(263, 'th', 'Thailand'),
(264, 'mobi', 'Mobile portals'),
(265, 'asia', 'Asia-Pacific region'),
(266, 'cat', 'Catalan'),
(267, 'jobs', 'companies'),
(268, 'tel', 'Internet communication services'),
(269, 'travel', 'travel and travel agency related'),
(270, 'eu', 'europe');

CREATE TABLE IF NOT EXISTS `#__digistore_logs` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` int(11) NOT NULL DEFAULT '0',
  `productid` int(11) NOT NULL DEFAULT '0',
  `emailname` text NOT NULL,
  `emailid` int(11) NOT NULL,
  `to` text NOT NULL,
  `subject` text NOT NULL,
  `body` text NOT NULL,
  `buy_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `send_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `download_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `buy_type` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__digistore_promocodes_orders` (
  `productid` int(11) NOT NULL,
  `promoid` int(11) NOT NULL,
  KEY `productid` (`productid`,`promoid`)
);

CREATE TABLE IF NOT EXISTS `#__digistore_promocodes_products` (
  `productid` int(11) NOT NULL,
  `promoid` int(11) NOT NULL,
  KEY `productid` (`productid`,`promoid`)
);

INSERT IGNORE INTO `#__digistore_tax_productclass` (`id`, `name`, `published`, `ordering`, `checked_out`, `checked_out_time`)
VALUES (1, 'General', 1, 0, 0, '0000-00-00 00:00:00');

INSERT IGNORE INTO `#__digistore_tax_customerclass` (`id`, `name`, `published`, `ordering`, `checked_out`, `checked_out_time`)
VALUES (1, 'Retail', 1, 0, 0, '0000-00-00 00:00:00'),
(2, 'Wholesale', 1, 0, 0, '0000-00-00 00:00:00');

INSERT IGNORE INTO `#__digistore_tax_rate` (`id`, `name`, `country`, `state`, `zip`, `rate`, `published`, `ordering`, `checked_out`, `checked_out_time`)
VALUES (1, 'USA CA', 'United-States', 'California', '*', 8.25, 1, 0, 0, '0000-00-00 00:00:00');

INSERT IGNORE INTO `#__digistore_tax_rule` (`id`, `name`, `cclass`, `pclass`, `trate`, `ptype`, `published`, `ordering`, `checked_out`, `checked_out_time`)
VALUES (1, 'Retail-General-USA-Software', '1', '1', '1', '1', 1, 0, 0, '0000-00-00 00:00:00'),
(2, 'Retail-General-USA-Hardware', '1', '1', '1', '2', 1, 0, 0, '0000-00-00 00:00:00');

CREATE TABLE IF NOT EXISTS `#__digistore_product_groups` (
  `id_product` INT( 11 ) NOT NULL ,
  `id_group` INT( 11 ) NOT NULL ,
  PRIMARY KEY (  `id_product` ,  `id_group` )
);

CREATE TABLE IF NOT EXISTS `#__digistore_product_groups_exp` (
  `id_product` INT( 11 ) NOT NULL ,
  `id_group` INT( 11 ) NOT NULL ,
  PRIMARY KEY (  `id_product` ,  `id_group` )
);

INSERT INTO `#__digistore_settings` (`id`,`currency`,`catalogue`,`showviewproducts`,`price_groups_separation`,`showproductdetails`,`store_name`,`store_url`,`store_email`,`product_per_page`,`google_account`,`country`,`state`,`city`,`tax_option`,`tax_rate`,`tax_type`,`totaldigits`,`decimaldigits`,`ftp_source_path`,`time_format`,`afteradditem`,`showreplic`,`idevaff`,`askterms`,`termsid`,`termsheight`,`termswidth`,`topcountries`,`usestoremail`,`catlayoutstyle`,`catlayoutcol`,`catlayoutrow`,`prodlayouttype`,`prodlayoutstyle`,`prodlayoutcol`,`prodlayoutrow`,`orderidvar`,`ordersubtotalvar`,`idevpath`,`askforship`,`person`,`taxnum`,`modbuynow`,`usecimg`,`showthumb`,`showsku`,`sendmailtoadmin`,`directfilelink`,`debugstore`,`dumptofile`,`dumpvars`,`ftranshtml`,`thankshtml`,`showprodshort`,`pendinghtml`,`address`,`zip`,`phone`,`fax`,`afterpurchase`,`showoid`,`showoipurch`,`showolics`,`showopaid`,`showodate`,`showorec`,`showlid`,`showlprod`,`showloid`,`showldate`,`showldown`,`showcam`,`showcpromo`,`showcremove`,`showccont`,`showldomain`,`tax_classes`,`tax_base`,`tax_catalog`,`tax_shipping`,`tax_discount`,`discount_tax`,`tax_country`,`tax_state`,`tax_zip`,`tax_price`,`tax_summary`,`shipping_price`,`product_price`,`tax_zero`,`tax_apply`,`usestorelocation`,`allowcustomerchoseclass`,`takecheckout`,`continue_shopping_url`,`currency_position`,`showlterms`,`showlexpires`,`storedesc`,`displaystoredesc`,`showfeatured`,`showrelated`,`hour24format`,`imagecatsizevalue`,`imagecatsizetype`,`imageprodsizefullvalue`,`imageprodsizefulltype`,`imageprodsizethumbvalue`,`imageprodsizethumbtype`,`imagecatdescvalue`,`imagecatdesctype`,`imageproddescvalue`,`imageproddesctype`,`mailchimplistid`,`showpowered`,`catlayoutimagesize`,`catlayoutimagetype`,`catlayoutdesclength`,`catlayoutdesctype`,`prodlayoutdesclength`,`prodlayoutdesctype`,`showfeatured_prod`,`prodlayoutthumbnails`,`prodlayoutthumbnailstype`,`prodlayoutlargeimgprev`,`prodlayoutlargeimgprevtype`,`prodlayoutlightimgprev`,`prodlayoutlightimgprevtype`,`showshortdescription`,`showlongdescription`,`showrelatedprod`,`last_check_date`,`prodlayoutsort`,`relatedrows`,`relatedcolumns`,`grid_image_align`,`grid_title_align`,`grid_subtitle_align`,`grid_description_align`,`grid_quantity_align`,`grid_add_to_cat_align`,`list_multi_selection`,`list_orientation`,`featured_row`,`featured_col`,`store_logo`,`shopping_cart_style`,`cart_width`,`cart_width_type`,`cart_alignment`,`prod_short_desc_class`,`prod_long_desc_class`,`prods_short_desc_class`,`prods_price_class`,`prods_name_class`,`cart_popoup_image`,`gallery_style`,`gallery_columns`,`in_trans`,`show_bradcrumbs`,`mailchimpapi`,`mailchimplist`,`showfacebook`,`showtwitter`,`showretwitter`,`newinstall`,`tax_eumode`,`askforbilling`,`show_steps`,`askforcompany`,`conversion_id`,`conversion_language`,`conversion_format`,`conversion_color`,`conversion_label`,`default_payment`,`thousands_group_symbol`) VALUES (1,'USD',0,1,',',1,'','','',10,'','','','','',0,'',5,2,'media','MM-DD-YYYY',0,0,'notapplied',0,0,-1,-1,'0',1,1,3,3,0,1,2,5,'order_id','order_subtotal','aff',1,1,0,0,0,1,0,1,0,0,0,'','','',0,'','','','','',1,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,'All','All','',0,0,0,0,0,'0',0,2,0,'',0,0,0,'',1,0,0,0,100,1,300,1,100,1,10,0,10,0,NULL,1,100,0,0,0,0,0,0,100,0,400,0,400,0,0,0,0,'0000-00-00 00:00:00',0,1,3,0,2,2,2,2,2,1,0,1,3,'',0,'100',1,1,'digi_short_desc_page','digi_long_desc_page','digi_short_desc_list','digi_price_list','digi_name_list',50,1,2,0,0,'','',1,1,1,1,0,0,0,0,'','en','2','ffffff','','',',');