<?php
// No direct access to this file
defined('_JEXEC') or die('Restricted access');
 
// import Joomla modelform library
jimport('joomla.application.component.modeladmin');

//error_reporting(E_ALL);  
/**
 * YoutubeGallery Model
 */
class YoutubeGalleryModelGalleryForm extends JModelAdmin
{
        /**
         * Returns a reference to the a Table object, always creating it.
         *
         * @param       type    The table type to instantiate
         * @param       string  A prefix for the table class name. Optional.
         * @param       array   Configuration array for model. Optional.
         * @return      JTable  A database object
         * @since       1.6
         */
		public $id;
		
        public function getTable($type = 'YoutubeGallery', $prefix = 'YoutubeGalleryTable', $config = array()) 
        {
                return JTable::getInstance($type, $prefix, $config);
        }
        /**
         * Method to get the record form.
         *
         * @param       array   $data           Data for the form.
         * @param       boolean $loadData       True if the form is to load its own data (default case), false if not.
         * @return      mixed   A JForm object on success, false on failure
         * @since       1.6
         */
        public function getForm($data = array(), $loadData = true) 
        {
				//echo '7676f';
                // Get the form.
                $form = $this->loadForm('com_youtubegallery.galleryform', 'galleryform', array('control' => 'jform', 'load_data' => $loadData));
				//echo 'abc';
                if (empty($form)) 
                {
                        return false;
                }
                return $form;
        }
		
		/**
         * Method to get the script that have to be included on the form
         *
         * @return string       Script files
         */
        public function getScript() 
        {
                return 'administrator/components/com_youtubegallery/models/forms/galleryform.js';
        }
		
        /**
         * Method to get the data that should be injected in the form.
         *
         * @return      mixed   The data for the form.
         * @since       1.6
         */
        protected function loadFormData() 
        {
                // Check the session for previously entered form data.
                $data = JFactory::getApplication()->getUserState('com_youtubegallery.edit.galleryform.data', array());
                if (empty($data)) 
                {
                        $data = $this->getItem();
                }
                return $data;
        }
        

        function store()
        {
                
                
        	$row =& $this->getTable('youtubegallery');
            

            
        	// consume the post data with allow_html
        	$data_ = JRequest::get( 'post',JREQUEST_ALLOWRAW);
            $data=$data_['jform'];
            
        	$post = array();
            
            $galleryname=trim(preg_replace("/[^a-zA-Z0-9_]/", "", $data['jform']['galleryname']));
            
            $data['jform']['galleryname']=$galleryname;
            
           

        	if (!$row->bind($data))
        	{
                
        		return false;
        	}
               
        	// Make sure the  record is valid
        	if (!$row->check())
        	{
                
        		return false;
        	}
				
				if($row->enablecache)
						$row->cache=$this->update_cache($row);
						
						
						
        	// Store
        	if (!$row->store())
        	{
                
        		return false;
        	}
				
        	$this->id=$row->id;
			
				
				
				
				
        	return true;
        }
        
        
		
		function update_cache(&$row)
		{
				require_once(JPATH_SITE.DS.'components'.DS.'com_youtubegallery'.DS.'includes'.DS.'misc.php');
				$misc=new YouTubeGalleryMisc;
				$misc->tablerow = &$row;
				
				$gallerylist=YouTubeGalleryMisc::csv_explode("\n", $row->gallerylist, '"', true);
				
				
				
				$firstvideo='';
				$gallerylist=$misc->formGalleryList($gallerylist,$row->showtitle, $row->description, $firstvideo, $firstvideo->showactivevideotitle);
				
				
				
				
				$result_array=array();
				
				foreach($gallerylist as $g)
				{
						$g_title=str_replace('"','&quot;',$g['title']);
						$g_description=str_replace('"','&quot;',$g['description']);
						
						$result_array[]=
								'"'.$g['videosource'].'",'
								.'"'.$g['videoid'].'",'
								.'"'.$g['imageurl'].'",'
								.'"'.$g_title.'",'
								.'"'.$g_description.'"';
				}
				
				$result=implode(';',$result_array);
				
				//echo 'result='.$result.'<br>';
				//die;
				return $result;
		}
		
		function delete($cids)
        {

        	$row =& $this->getTable('youtubegallery');

            $db = & JFactory::getDBO();
            
        	if (count( $cids ))
        	{
        		foreach($cids as $cid)
        		{
						
				
				if (!$row->delete( $cid ))
				{
					return false;
				}
			}
        	}
		
		
		
        	return true;
        }
}
