<?php
/**
 * @version		1.0
 * @Project		Facebook The Like Box In The Article
 * @author 		Leon Wood, cmsvoteup.com
 * @package		
 * @copyright	Copyright (C) 2011 cmsvoteup.com. All rights reserved.
 * @license 	http://www.gnu.org/licenses/old-licenses/gpl-2.0.html GNU/GPL version 2
*/

// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgContentfacebook_the_like_box_in_the_article extends JPlugin {

	function plgContentfacebook_the_like_box_in_the_article( &$subject, $config )
	{
		parent::__construct( $subject, $config );
	}

	function onContentPrepare($context, &$article, &$params, $page=0)
	{	
		
		$document	= & JFactory::getDocument();
		$view		= JRequest::getCmd('view');
		$position          = $this->params->get( 'position',  '' );
		
		if ( $view != 'article' ) { 
			return;	
		} else {
			$title= htmlentities( $article->title, ENT_QUOTES, "UTF-8");
			$url = $this->getPageUrl($article);
			
			if ($position == '1'){
				$article->text =  $this->getPlugInHTML($this->params, $article, $url, $title) . $article->text;  
			}
			if ($position == '2'){
				$article->text = $article->text . $this->getPlugInHTML($this->params, $article, $url, $title);
			}
			if ($position == '3'){
				$article->text =  $this->getPlugInHTML($this->params, $article, $url, $title) . $article->text . $this->getPlugInHTML($this->params, $article, $url, $title);
			}			
		}
			
	}
	
	private function  getPlugInHTML($params, $article, $url, $title) { 
		$category_tobe_excluded   = $this->params->get('category_tobe_excluded', '' );
		$content_tobe_excluded           = $this->params->get('content_tobe_excluded', '' );
		$excludedCatList = @explode ( ",", $category_tobe_excluded );	
		$excludedContentList 	   = @explode ( ",", $content_tobe_excluded );		
		$cssStyle   = $this->params->get('cssStyle', '' );
		
		$pageURL = $this->params->get('pageURL', '');  ////example of Page URL : http://www.facebook.com/pages/CMS-Vote-Up/101900273224629
		
		$width = $this->params->get('width', '480'); 
		//Selected Color Scheme
		$colorScheme = $this->params->get('colorScheme');
		//Show the profile stream for Public Profile
		$streams = $this->params->get('streams'); 
		//Show the profile photo
		$showFaces = $this->params->get('showFaces'); 
		//Show the Find Us on Facebook bar at top. Only shown when either stream or connections are present
		$header = $this->params->get('header'); 
		$power_by = $this->params->get('power_by'); 

		if ( in_array ( $article->id, $excludedContentList ) || in_array ( $article->catid, $excludedCatList ) ) return;
		
		$htmlCode ="<div style='$cssStyle'>";
		$htmlCode .= "<div id=\"fb-root\"></div><script src=\"http://connect.facebook.net/en_US/all.js#xfbml=1\"></script><fb:like-box href=\"$pageURL\" width=\"$width\" show_faces=\"$showFaces\" colorscheme=\"$colorScheme\" stream=\"$streams\" header=\"$header\"></fb:like-box>";
		if ($power_by == "true") {
		$htmlCode .= "<a href=\"http://cmsvoteup.com/category/joomla-extensions/\" title=\"Vote For The Best Joomla Plugins and Extensions\" target=\"_blank\"><img src=\"http://www.cmsvoteup.com/images/power_by_2x2.gif\" border=\"0\"/></a>"; 
		}
		$htmlCode .= "</div>";
		
     return $htmlCode; 
	}
	
	private function getPageUrl($obj)
	{
		if (!is_null($obj)) 
		{
			$url = JRoute::_(ContentHelperRoute::getArticleRoute($obj->slug, $obj->catslug, $obj->sectionid));
			$uri = JURI::getInstance();
      		$base  = $uri->toString( array('scheme', 'host', 'port'));
			$url = $base . $url;
			$url = JRoute::_($url, true, 0);
			return $url;
		}
	}
}
?>