<?php
/**
* @version 1.7
* @package PWeb Facebook Link content image
* @copyright Copyright (C) 2011 Majestic Media sp. z o.o., All rights reserved.
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
* @author url: http://www.perfect-web.pl
* @author email biuro@perfect-web.pl
*/

// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );


class plgContentFBLinkContentImage extends JPlugin
{
	function plgContentFBLinkContentImage( &$subject, $params ) {
		
		parent::__construct( $subject, $params );
	}
	
	function _addHeadLinkImg($text) {
	
		if (!defined('PLG_FBLINKCONTENTIMAGE') and $text != '') {
			
			$document = &JFactory::getDocument();
			
			if ($this->params->get('home', 0) and ($href = $this->params->get('default_image')) != '' ) {
				
				$menus = &JSite::getMenu();
				$menu = $menus->getActive();

				if (is_object( $menu )) {
					if ($menu->home) {
						$document->addCustomTag('<meta property="og:image" content="'.$href.'"/>');
						define('PLG_FBLINKCONTENTIMAGE', 1);
						return true;
					}
				}	
			}
			
			if ($this->params->get('only_articles', 1)) {
				if (JRequest::getVar('view') != 'article') return false;
			}
			
			if ($this->params->get('all_images', 0) == 0) {
			
				preg_match('/src=[\\"\']?([^\\"\']+\.(png|jpg|gif))[\\"\']?/i', $text, $image);
				
				if (array_key_exists(1, $image)) {
					
					$href = $image[1];
					if (substr($href, 0, 7) != 'http://') {
						if (substr($href, 0, 1) == '/') $href = substr($href, 1);
						$href = JURI::base().$href;
					}
					
					$document->addCustomTag('<meta property="og:image" content="'.$href.'"/>');
					define('PLG_FBLINKCONTENTIMAGE', 1);
					
				} else if (($href = $this->params->get('default_image')) != '' and JRequest::getVar('view') == 'article') {
					
					$document->addCustomTag('<meta property="og:image" content="'.$href.'"/>');
					define('PLG_FBLINKCONTENTIMAGE', 1);
				}
			}
			else {
				
				preg_match_all('/src=[\\"\']?([^\\"\']+\.(png|jpg|gif))[\\"\']?/i', $text, $images);
				
				if (array_key_exists(1, $images)) {
					
					$images = $images[1];
					
					foreach ($images as $href) {
						
						if (substr($href, 0, 7) != 'http://') {
							if (substr($href, 0, 1) == '/') $href = substr($href, 1);
							$href = JURI::base().$href;
						}
						$document->addCustomTag('<meta property="og:image" content="'.$href.'"/>');
					}
				}
			}
		}
	}
	
	function onContentPrepare($context, &$article, &$params) {
		
		if ($this->params->get('event', 0) == 1) {
			if ($context == 'com_content.article') {
				$text = $article->introtext ? $article->introtext : $article->text;
				$this->_addHeadLinkImg( $text );
			}
			else if ($context == 'text') {
				$text = $article->text;
				$this->_addHeadLinkImg( $text );
			}
		}
	}
	
	function onContentAfterDisplay($context, &$article, &$params) {
		
		if ($this->params->get('event', 0) == 0) {
			if ($context == 'com_content.article') {
				$text = $article->introtext ? $article->introtext : $article->text;
				$this->_addHeadLinkImg( $text );
			}
		}
	}

}
