<?php
/**
 * @package ZT Share Plugin for Joomla! 1.7
 * @author http://www.ZooTemplate.com
 * @copyright(C) 2011- ZooTemplate.Com
 * @license PHP files are GNU/GPL
**/

defined('_JEXEC') or die('Restricted access');
jimport('joomla.plugin.plugin');
require_once(JPATH_ROOT.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php');

global $app;
$app->registerEvent('onContentBeforeDisplay', 'showPrepareContent');

function showPrepareContent($context, &$row, &$params, $page = 0)
{
	$class = new ZTContentShare;
	$class->onContentBeforeDisplay($context, $row, $params, $page = 0);
}


class ZTContentShare extends JPlugin
{
	var $fbshare_pos 	= null; 
	var $home 			= null; 
	var $com 			= null; 
	var $cate 			= null; 
	var $k2cate 		= null; 
	var $show_linked 	= null; 
	var $show_ztplus 	= null;
	
	var $position_linked 	= null; 
	var $position_ztplus 	= null; 
	var $show_zttweet 		= null; 
	var $position_zttweet 	= null; 
	var $show_ztfblike 		= null; 
	var $position_ztfblike 	= null;
	
	var $show_digg 		= null; 
	var $position_digg 	= null; 
	var $info 			= null; 
	var $listpage 		= null; 
	var $art_ex 		= null; 
	var $art_content 	= array();
	var $art_k2 		= array();
	
	
	public function ZTContentShare()
	{	
		// load plugin parameters
		$this->_plugin = JPluginHelper::getPlugin('system', 'plg_zt_share');
		$this->_params = new JRegistry($this->_plugin->params);
		
		// get param homepage
		$this->home = $this->_params->def('homepage', 1);  
		$this->cate = $this->_params->get('content_cate', ''); 
		
		// get param show linkedin
		$this->show_linked = $this->_params->get('show_linked', 1);
		$this->position_linked = $this->_params->get('position_linked', 'before_content');
		
		// get param show zt google plus
		$this->show_ztplus = $this->_params->get('show_ztplus', 1);
		$this->position_ztplus = $this->_params->get('position_ztplus', 'before_content');
		
		// get param show zt tweeter
		$this->show_zttweet = $this->_params->get('show_tweeter', 1);
		$this->position_zttweet = $this->_params->get('position_tweeter', 'before_content');
		
		// get param show zt tweeter
		$this->show_ztfblike = $this->_params->get('show_fblike', 1);
		$this->position_ztfblike = $this->_params->get('position_fblike', 'before_content');
		
		// get param show zt digg
		$this->show_digg = $this->_params->get('show_digg', 1);
		$this->position_digg = $this->_params->get('position_digg', 'before_content');
		
		// get param show plugin list page
		$this->listpage = $this->_params->def('listpage', 1);
		
		// get article exlude from config
		$this->art_ex = $this->_params->get('article_id', '');
		
		// get array article exclude
		$art_arr = explode(";", $this->art_ex);
		for($i = 0; $i < count($art_arr); $i++)
		{
			$art = explode("_", $art_arr[$i]);
			// article is content
			if($art[0] == 'content')
				array_push($this->art_content, $art[1]);
		}
		
		$this->info = '';
	}
	
	function setOpenGraphData(&$row, &$params, $image, $link)
	{
		$document	= &JFactory::getDocument();
		
		if(strlen($row->title) > 1)
			$document->setMetaData("og:title", $row->title);
		
		$document->setMetaData("og:type", "website");
		
		//$document->setMetaData("og:url", JURI::base() . $link);
		
		if(strlen($row->metadesc) > 1)
		{
			$document->setDescription($row->metadesc);
			$document->setMetaData("og:description", $row->metadesc);
		}
		else
		{
			if(strlen($row->introtext) > 1)
			{
				$metaDescItem = preg_replace("#{(.*?)}(.*?){/(.*?)}#s", '', $row->introtext.' '.$row->fulltext);
				$metaDescItem = $this->characterLimit($metaDescItem, $params->get('metaDescLimit', 150));
				
				$document->setMetaData("og:description", $metaDescItem);
				$document->setDescription($metaDescItem);
				$article->metadesc = $metaDescItem;
			}
		}
		
		if($image != "") {
			$image = (strpos($image, "http://") === FALSE) ? JURI::base() . $image : $image;
			$document->setMetaData("og:image", $image);
		}
	}
	
	public function characterLimit($str, $limit = 150, $end_char = '...')
	{
		if(trim($str) == '') return $str;
		
		// always strip tags for text
		$str = strip_tags(trim($str));
		
		$find 		= array("/\r|\n/","/\t/","/\s\s+/");
		$replace 	= array(" "," "," ");
		$str 		= preg_replace($find,$replace,$str);
		
		if(strlen($str)>$limit)
		{
			if(function_exists("mb_substr"))
			{
				$str = mb_substr($str, 0, $limit);
			}
			else
			{
				$str = substr($str, 0, $limit);
			}
			return rtrim($str).$end_char;
		}
		else
		{
			return $str;
		}
	}
	
	public function onContentBeforeDisplay($context, &$row, &$params, $page = 0)
	{
		$after 		= '';
		$before 	= '';
		$btn_share	= '';
		$btn_like	= '';
		$option 	= JRequest::getVar('option');
		$document	= &JFactory::getDocument();
		$id			= JRequest::getInt("id");
		$link		= ContentHelperRoute::getArticleRoute($id, $row->catid);
		
		preg_match('/<img(.*?)src="(.*?)"(.*?)>/si', $row->introtext, $match);
		$image = (count($match)) ? $match[2] : "";
		
		if($id == $row->id && $this->is_com_content($row)) {
			$this->setOpenGraphData($row, $params, $image, $link);
		}		
		
		$linkedorder 	= $this->_params->get('linkedin_order');
		$gplusorder 	= $this->_params->get('googleplus_order');
		$tweetorder 	= $this->_params->get('tweeter_order');
		$faceorder 		= $this->_params->get('facebook_order');
		$diggorder 		= $this->_params->get('digg_order');
		$view 			= JRequest::getString('view', '');
				
		$document->addStylesheet(JURI::root().'plugins/system/plg_zt_share/plg_zt_share/assets/css/style.css');
		
		if($this->is_com_content($row))
		{
			if(($this->listpage != 1) && (!$this->is_view_page()) && (!$this->showHome()))
			{
				$after = '';
				$before = '';
			}
			else
			{
				for($i = 1; $i <= 5; $i ++)
				{
					if($this->show_linked > 0 && $linkedorder == $i)
					{
						if($this->position_linked == 'before_content')
							$before .= $this->zt_linkedin($row, $params);
						else
							$after .= $this->zt_linkedin($row, $params);
					}
					
					//Google Plus Block
					if($this->show_ztplus > 0 && $gplusorder == $i)
					{
						$document->addScript('https://apis.google.com/js/plusone.js');
						
						if($this->position_ztplus == 'before_content')
							$before .= $this->zt_googleplus($row, $params);
						else
							$after .= $this->zt_googleplus($row, $params);						
					}
					
					//Twitter Block
					if($this->show_zttweet > 0 && $tweetorder == $i)
					{
						$document->addScript('http://platform.twitter.com/widgets.js');
						
						if($this->position_zttweet == 'before_content')
							$before .= $this->zt_tweeter($row, $params);
						else
							$after .= $this->zt_tweeter($row, $params);						
					}
					
					//Digg Block
					if($this->show_digg > 0 && $diggorder == $i)
					{						
						if($this->position_digg == 'before_content')
							$before .= $this->zt_diggbutton($row, $params);
						else
							$after .= $this->zt_diggbutton($row, $params);						
					}
					
					//Facebook Block
					if($this->show_ztfblike > 0 && $faceorder == $i)
					{
						if($this->position_ztfblike == 'before_content')
							$before .= $this->zt_facebooklike($row, $params);
						else
							$after .= $this->zt_facebooklike($row, $params);						
					}
				}
			}
			
			$before = '<div class="jv-social-share-button-contain">'.$before.'</div>';
			$after  = '<div class="jv-social-share-button-contain">'.$after.'</div>';
			
			if($view == 'article')
			{
				$row->text = $before.$row->text.$after.$this->info;
			}
			else
			{
				$row->introtext = $before.$row->introtext.$after.$this->info;
			}
		}
	}
	
	
	public function zt_linkedin(&$row, &$params)
	{
		$option = JRequest::getVar('option');
		$view 	= JRequest::getVar('view');
		$id		= JRequest::getInt('id');
		$uri	= JFactory::getURI();
		
		$linked_width = $this->_params->get('linked_width');
		$linked_count = $this->_params->get('linked_count', 'right');
		$root_url	  = $uri->toString(array('scheme', 'host', 'port'));
		
		if($this->is_com_content($row))
			$cate_url = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug));
			
		$url = $root_url.$cate_url;
		
		$linkedin = "<div class=\"zt-linkedin\" style=\"width: ".$linked_width."px\">
		<script type=\"text/javascript\" src=\"http://platform.linkedin.com/in.js\"></script>
		<script type=\"in/share\" data-url=\"".$url."\" data-counter=\"".$linked_count."\"></script></div>";
		
		$ztlinkedinshow = ($view == 'frontpage' && $this->home != 1) ? '' : $linkedin;
		
		if($this->com == 'com_content')
			$ztlinkedinshow = ($this->is_com_content($row) == 1) ? $linkedin : "";			
		
		$catid = $row->catid;
		// filter com_content category 
		if($this->is_com_content($row))
		{
			if(is_array($this->cate))
				$categories = $this->cate;
			elseif($this->cate == '')
				$categories[] = $catid;
			else
				$categories[] = $this->cate;
			
			if(!in_array($catid , $categories))
				$ztlinkedinshow = '';
		}
		
		// check exclude article com content
		if($this->is_com_content($row))
		{
			if(in_array($row->id ,$this->art_content))
				$ztlinkedinshow = '';
		} 
		
		return $ztlinkedinshow;
	}
	
	
	public function zt_googleplus(&$row, &$params)
	{
		$option = JRequest::getVar('option');
		$view 	= JRequest::getVar('view');
		$id		= JRequest::getInt('id');
		$uri	= JFactory::getURI();
		
		$gplus_width = $this->_params->get('gplus_width');
		$size_button = $this->_params->get('size_button', 'medium');
		$show_count  = $this->_params->get('show_count', 1);
		
		$count 		= ($show_count > 0) ? 'true' : 'false';
		$root_url	= $uri->toString(array('scheme', 'host', 'port'));
		$lang 		= JFactory::getLanguage();
		$langdf 	= $lang->getTag();
		$langstr 	= str_replace("-", "_", $langdf);
		
		if($this->is_com_content($row)) {
			$cate_url = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug));
		}
		
		$url    = $root_url.$cate_url;
		$ztplus = "<div class=\"zt-googleplus\" style=\"width: ".$gplus_width."px\">
		<g:plusone size=\"$size_button\" count=\"$count\" href=\"$url\" lang=\"$langstr\"></g:plusone></div>";
		
		$ztplusshow = '';
		$ztplusshow = ($view == 'frontpage' && $this->home != 1) ? "" : $ztplus;
		
		if($this->com == 'com_content')
			$ztplusshow = ($this->is_com_content($row) == 1) ? $ztplusshow : "";			
		
		$catid = $row->catid;
		
		// filter com_content category 
		if($this->is_com_content($row))
		{
			if(is_array($this->cate))
				$categories = $this->cate;
			elseif($this->cate == '')
				$categories[] = $catid;
			else
				$categories[] = $this->cate;
			
			if(!in_array($catid , $categories))
				$ztplusshow = '';
		}
		
		// check exclude article com content
		if($this->is_com_content($row))
		{
			if(in_array($row->id ,$this->art_content))
				$ztplusshow = '';
		}
		
		return $ztplusshow;
	}
	
	
	public function zt_tweeter(&$row, &$params)
	{
		$option = JRequest::getVar('option');
		$view 	= JRequest::getVar('view');
		$id		= JRequest::getInt('id');
		$uri	= JFactory::getURI();
		
		$tweet_width = $this->_params->get('tweet_width');
		$tweet_count = $this->_params->get('tweet_count', 'horizontal'); 
		$root_url	 = $uri->toString(array('scheme', 'host', 'port'));
		
		$lang 	 = JFactory::getLanguage();
		$langdf  = $lang->getTag();
		$langstr = str_replace("-", "_", $langdf);
		
		if($this->is_com_content($row))
			$cate_url = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug));
			
		$url       = $root_url.$cate_url;
		$zttweeter = "<div class=\"zt-tweeter\" style=\"width: ".$tweet_width."px\">
		<a href=\"http://twitter.com/share\" class=\"twitter-share-button\" data-url=\"$url\" data-lang = \"$langstr\" 
		data-count=\"$tweet_count\">".JText::_('Tweet')."</a></div>";
		
		$zttweetershow = ($view == 'frontpage' && $this->home != 1) ? "" : $zttweeter;
		
		if($this->com == 'com_content')
			$zttweetershow = ($this->is_com_content($row) == 1) ? $zttweetershow : "";
			
		$catid = $row->catid;
		
		// filter com_content category 
		if($this->is_com_content($row))
		{
			if(is_array($this->cate))
				$categories = $this->cate;
			elseif($this->cate == '')
				$categories[] = $catid;
			else
				$categories[] = $this->cate;
			
			if(!in_array($catid , $categories))
				$zttweetershow = '';			
		}
		
		// check exclude article com content
		if($this->is_com_content($row))
		{
			if(in_array($row->id ,$this->art_content))
				$zttweetershow = '';			
		} 
		
		return $zttweetershow;
	}
	
	
	public function zt_facebooklike(&$row, &$params)
	{
		$option = JRequest::getVar('option');
		$view 	= JRequest::getVar('view');
		$id		= JRequest::getInt('id');
		$uri	= JFactory::getURI();
		
		$fb_appid	= $this->_params->get('fb_appid');
		$fbwidth	= $this->_params->get('fb_width', '300');
		$send_width	= $this->_params->get('send_width', '65');
		$show_faces	= $this->_params->get('show_faces', 1);
		
		$show_fbsend	= $this->_params->get('show_fbsend', 1);
		$s_faces 		= ($show_faces > 0) ? 'true' : 'false';
		
		$fb_style	= $this->_params->get('fb_style', 'standard');
		$fb_font	= $this->_params->get('fb_font');
		$fb_color	= $this->_params->get('fb_color_scheme', 'light');
		$root_url	= $uri->toString(array('scheme', 'host', 'port'));
		
		$lang    = JFactory::getLanguage();
		$langdf  = $lang->getTag();
		$langstr = str_replace("-", "_", $langdf);
		
		if($this->is_com_content($row))
			$cate_url = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug));
		
		$url 		 = $root_url.$cate_url;
		$zt_facebook = "<div id=\"fb-root\"></div><script src=\"http://connect.facebook.net/$langstr/all.js#appId=$fb_appid&amp;xfbml=1\"></script>";
		
		if($show_fbsend > 0)
			$zt_facebook .= "<div class=\"zt-facebook-send\" style=\"width: ".$send_width."px\"><fb:send href=\"$url\" font=\"$fb_font\"></fb:send></div>";
		
		$zt_facebook .= "<div class=\"zt-facebook-like\">
		<fb:like href=\"$url\" width=\"$fbwidth\" show_faces=\"$s_faces\" layout=\"$fb_style\" action=\"like\" font=\"$fb_font\" colorscheme=\"$fb_color\"></fb:like>
		</div>";
		
		$ztfbshow = ($view == 'frontpage' && $this->home != 1) ? "" : $zt_facebook;
			
		if($this->com == 'com_content')
			$ztfbshow = ($this->is_com_content($row) == 1) ? $ztfbshow : "";			
		
		$catid = $row->catid;
		
		// filter com_content category 
		if($this->is_com_content($row))
		{
			if(is_array($this->cate))
				$categories = $this->cate;
			elseif($this->cate == '')
				$categories[] = $catid;
			else
				$categories[] = $this->cate;
			
			if(!in_array($catid , $categories))
				$ztfbshow = '';		
		}
		
		// check exclude article com content
		if($this->is_com_content($row))
		{
			if(in_array($row->id ,$this->art_content))
				$ztfbshow = '';
		}
		
		return $ztfbshow;
	}
	
	
	public function zt_diggbutton(&$row, &$params)
	{
		$option = JRequest::getVar('option');
		$view 	= JRequest::getVar('view');
		$id		= JRequest::getInt('id');
		$uri	= JFactory::getURI();
		
		$digg_width			= $this->_params->get('digg_width', '85');
		$digg_buttonsize	= $this->_params->get('digg_button_size', 'DiggCompact');
		
		$root_url	= $uri->toString(array('scheme', 'host', 'port'));
		$lang 		= JFactory::getLanguage();
		$langdf 	= $lang->getTag();
		$langstr 	= str_replace("-", "_", $langdf);
		
		if($this->is_com_content($row))
			$cate_url = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug));
			
		$url = $root_url.$cate_url;
		
		$zt_diggbutton = "<div class=\"zt_diggbutton\" style=\"width: ".$digg_width."px\">
		<script type=\"text/javascript\">(function() { var s = document.createElement('SCRIPT'), s1 = document.getElementsByTagName('SCRIPT')[0]; 
		s.type = 'text/javascript'; s.async = true; s.src = 'http://widgets.digg.com/buttons.js'; 
		s1.parentNode.insertBefore(s, s1); })();</script><a class=\"DiggThisButton $digg_buttonsize\" href=\"http://digg.com/submit?url=$url\"></a></div>";
		
		$ztdiggshow = '';
		$ztdiggshow = ($view == 'frontpage' && $this->home != 1) ? "" : $zt_diggbutton;
		
		if($this->com == 'com_content')
			$ztfbshow = ($this->is_com_content($row) == 1) ? $ztfbshow : "";
		
		$catid = $row->catid;
		
		// filter com_content category 
		if($this->is_com_content($row))
		{
			if(is_array($this->cate))
				$categories = $this->cate;
			elseif($this->cate == '')
				$categories[] = $catid;
			else
				$categories[] = $this->cate;
			
			if(!in_array($catid , $categories))
				$ztdiggshow = '';
		}
		
		// check exclude article com content
		if($this->is_com_content($row)) {
			if(in_array($row->id ,$this->art_content))
				$ztdiggshow = '';
		}
		
		return $ztdiggshow;
	}
	
	
	public function is_com_content($row)
	{
		return(isset($row->catid)) ? true : false;
	}
	
	
	public function showHome()
	{
		$view = JRequest::getVar('view');
		return ($view == 'frontpage' && $this->home == '1') ? true : false;
	}
	
	
	public function is_view_page() 
	{
		$option = JRequest::getVar('option');
		$view 	= JRequest::getVar('view');
		
		//if its a view page
		return (($option == 'com_content' && $view == 'article')) ? true : false;
	}
}

class plgSystemPlg_zt_share extends JPlugin
{
	
	var $url			= NULL;
	var $Itemid			= NULL;
	var $langstr		= NULL;
	var $document		= NULL;
	
	var $show_popup		= NULL;
	var $title_popup	= NULL;
	var $content_popup	= NULL;
	var $ecount_down	= NULL;
	var $count_down		= NULL;
	var $show_popup_in	= NULL;		
	
	var $show_linked	= NULL;
	var $linked_order	= NULL;
	var $linked_count	= NULL;
	var $linked_width	= NULL;
	
	var $google_plus	= NULL;
	var $google_order	= NULL;
	var $google_size	= NULL;
	var $google_count	= NULL;
	var $google_width	= NULL;
	
	var $show_tweeter	= NULL;
	var $tweeter_order	= NULL;
	var $tweet_count	= NULL;
	var $tweet_width	= NULL;
	
	var $show_fblike	= NULL;
	var $fblike_order	= NULL;
	var $show_fbsend	= NULL;
	var $show_faces		= NULL;
	var $fb_style		= NULL;
	var $fb_font		= NULL;
	var $fb_appid		= NULL;
	var $send_width		= NULL;
	var $fbwidth		= NULL;
	var $fb_color_scheme = NULL;
	
	var $show_digg		= NULL;
	var $digg_order		= NULL;
	var $digg_width		= NULL;
	var $digg_button_size = NULL;
	
	function __construct(&$subject, $config)
	{
		parent::__construct($subject, $config);
		
		$this->url				= JFactory::getURI()->toString();
		$this->document			= &JFactory::getDocument();
		$this->langstr			= str_replace("-", "_", JFactory::getLanguage()->getTag());
		
		$this->show_popup 		= $this->params->get('show_popup', 1);
		$this->title_popup		= $this->params->get('title_popup', '');
		$this->content_popup	= $this->params->get('content_popup', '');
		$this->ecount_down		= $this->params->get('enable_count_down', 1);
		$this->count_down		= $this->params->get('count_down', 30000);
		$this->show_popup_in	= (is_array($this->show_popup)) ? $this->show_popup : array($this->show_popup);		
		
		$this->show_linked 		= $this->params->get('show_linked', 1);
		$this->linked_order		= $this->params->get('linkedin_order', 1);
		$this->linked_count		= $this->params->get('linked_count', 'right');
		$this->linked_width		= $this->params->get('linked_width', 100);
		
		$this->google_plus 		= $this->params->get('show_ztplus', 1);
		$this->google_order		= $this->params->get('googleplus_order', 1);
		$this->google_size		= $this->params->get('size_button', 'medium');
		$this->google_count		= $this->params->get('show_count', 1);
		$this->google_width		= $this->params->get('gplus_width', 70);
		
		$this->show_tweeter		= $this->params->get('show_tweeter', 1);
		$this->tweeter_order	= $this->params->get('tweeter_order', 1);
		$this->tweet_count		= $this->params->get('tweet_count', 1);
		$this->tweet_width		= $this->params->get('tweet_width', 105);
		
		$this->show_fblike		= $this->params->get('show_fblike', 1);
		$this->fblike_order		= $this->params->get('facebook_order', 1);
		$this->show_fbsend		= $this->params->get('show_fbsend', 1);
		$this->show_faces		= $this->params->get('show_faces', 1);
		$this->fb_style			= $this->params->get('fb_style', 'button_count');
		$this->fb_font			= $this->params->get('fb_font', '');	
		$this->fb_appid			= $this->params->get('fb_appid', '');
		$this->send_width		= $this->params->get('send_width', 65);
		$this->fbwidth			= $this->params->get('fb_width', 65);
		$this->fb_color_scheme 	= $this->params->get('fb_color_scheme', '');
		
		$this->show_digg		= $this->params->get('show_digg', 1);
		$this->digg_order		= $this->params->get('digg_order', 1);
		$this->digg_width		= $this->params->get('digg_width', 85);
		$this->digg_button_size = $this->params->get('digg_button_size', 'DiggCompact');
	}
	
	public function onAfterRoute()
	{
		global $app;
		if($app->isSite())
		{
			if($this->show_linked)
				$this->document->addScript('http://platform.linkedin.com/in.js');
				
			if($this->google_plus)
				$this->document->addScript('https://apis.google.com/js/plusone.js');
			
			if($this->show_tweeter)
				$this->document->addScript('http://platform.twitter.com/widgets.js');
		}
	}
	
	public function onAfterRender()
	{
		global $app;
		
		if($app->isSite())
		{
			$this->Itemid = JSite::getMenu()->getActive()->id;
			//The content of popup
			if(in_array($this->Itemid, $this->show_popup_in) && !@$_COOKIE[md5(JURI::base() . $this->Itemid)])
			{
				$html  = $this->getSocialButton();
				
				$head  = '<link rel="stylesheet" href="'.JURI::base().'plugins/system/plg_zt_share/plg_zt_share/assets/css/popup.css" type="text/css" />';
				$head  = $head . '<script src="'.JURI::base().'plugins/system/plg_zt_share/plg_zt_share/assets/js/lady-overlay.js" type="text/javascript"></script>';
				
				$popup = '<div id="ztmain-popup">
								<div id="ztpopup-title"><a id="ztmain-popup_close" href="#">Close</a>'.$this->title_popup.'</div>
								<div id="ztpopup-msg-content">
									<div id="ztpopup-msg">'.$this->content_popup.'</div>
									'.$html.'
									<div class="step-clear"></div>
								</div>
								<div id="ztpopup-bottom">
									'.(($this->count_down) ? ('Share or wait <span id="count-down">'.$this->count_down.'</span> seconds. ') : 'Thank you very much !').'
								</div>
							</div>
							<script language="javascript" type="text/javascript">
							window.addEvent("load", function(){     
								new LadyOverlay("ztmain-popup", {
									countdown: "count-down",
									transition: Fx.Transitions.linear,
									duration: 350,
									wait: '.($this->count_down * 1000).',
									url: "'. md5(JURI::base() . $this->Itemid) .'"
								});	
							});
							</script>';
				
				$_body = JResponse::getBody();
				$_body = str_replace("</head>", $head . "</head>", $_body);
				$_body = str_replace("</body>", $popup . "</body>", $_body);
				JResponse::setBody($_body);
			}
		}
	}
	
	public function getSocialButton()
	{
		$array = array();	
		
		//Linked block
		$linkedin = "<div class=\"zt-linkedin\" style=\"width: ".$this->linked_width."px\">
		<script type=\"in/share\" data-url=\"".$this->url."\" data-counter=\"".$this->linked_count."\"></script></div>";
		
		if($this->show_linked)
			$array = array($this->linked_order => $linkedin);
			
		//Google Plus Block
		$ztplus = "<div class=\"zt-googleplus\" style=\"width: ".$this->google_width."px\">
		<g:plusone size=\"".$this->google_size."\" count=\"".$this->google_count."\" href=\"".$this->url."\" lang=\"".$this->langstr."\"></g:plusone></div>";
		
		if($this->google_plus)
			$array = array($this->linked_order => $linkedin, $this->google_order => $ztplus);
		
		//Twitter block
		$zttweeter = "<div class=\"zt-tweeter\" style=\"width: ".$this->tweet_width."px\">
		<a href=\"http://twitter.com/share\" class=\"twitter-share-button\" data-url=\"".$this->url."\" 
		data-lang = \"".$this->langstr."\" data-count=\"".$this->tweet_count."\">".JText::_('Tweet')."</a></div>";
		
		if($this->show_tweeter)
			$array = array($this->linked_order => $linkedin, $this->google_order => $ztplus, $this->tweeter_order => $zttweeter);		
		
		//Facebook block
		$zt_facebook = "<div id=\"fb-root\"></div>
		<script src=\"http://connect.facebook.net/".$this->langstr."/all.js#appId=".$this->fb_appid."&amp;xfbml=1\"></script>";
		
		if($this->show_fbsend)
			$zt_facebook .= "<div class=\"zt-facebook-send\" style=\"width: ".$this->send_width."px\">
			<fb:send href=\"".$this->url."\" font=\"".$this->fb_font."\"></fb:send></div>";
		
		if($this->show_fblike)
			$zt_facebook .= "<div class=\"zt-facebook-like\"><fb:like href=\"".$this->url."\" width=\"".$this->fbwidth."\" show_faces=\"".$this->show_faces."\" 
			layout=\"".$this->fb_style."\" action=\"like\" font=\"".$this->fb_font."\" colorscheme=\"".$this->fb_color_scheme."\"></fb:like></div>";
		
		$array = array($this->linked_order => $linkedin, $this->google_order => $ztplus, $this->tweeter_order => $zttweeter, $this->fblike_order => $zt_facebook);
		
		//Digg Block
		$zt_diggbutton = "<div class=\"zt_diggbutton\" style=\"width: ".$this->digg_width."px\">
		<script type=\"text/javascript\">(function() { var s = document.createElement('SCRIPT'), s1 = document.getElementsByTagName('SCRIPT')[0]; 
		s.type = 'text/javascript'; s.async = true; s.src = 'http://widgets.digg.com/buttons.js'; s1.parentNode.insertBefore(s, s1); })();</script>
		<a class=\"DiggThisButton ".$this->digg_button_size."\" href=\"http://digg.com/submit?url=".$this->url."\"></a></div>";
		
		if($this->show_digg)
			$array = array($this->linked_order => $linkedin, $this->google_order => $ztplus, $this->tweeter_order => $zttweeter, 
			$this->fblike_order => $zt_facebook, $this->digg_order => $zt_diggbutton);
		
		ksort($array);
		
		$html = implode("", $array);
		return $html;
	}
}
?>